//
// C++ Interface: range
//
// Description: 
//
//
// Author: fmt <fmt@localhost.localdomain>, (C) 2008
//
// Copyright: See COPYING file that comes with this distribution
//
//

#ifndef RANGE_IMPLEMENTATION_H
#define RANGE_IMPLEMENTATION_H
#include "ui_range.h"
#include "projectwizard.h"

class LineDocProperty;
class PropertyValue;
class MDocument;
class RangeImpl : public QDialog, private Ui::RangeBase {
    Q_OBJECT

public:
    RangeImpl(QWidget *parent,MDocument* doc,ProWizard::DocumentUsing documentUsing);
    void SetRangeWaveList(QStringList &RangeWaveListTmp,float min,float max);
    void FinishWizard();
    bool CheckDialogParameeters();
private slots:
    void setsel();
    void setall();
    void applay();
    void doubleClickGridList(const QModelIndex & index);
private:
    MDocument* doc;
    ProWizard::DocumentUsing documentUsing;
    void InitDialog();
    void SetDocumentToDialog();
    void GetDocumentFromDialog();
    QList<PropertyValue* > values;
    QList<LineDocProperty* > propDocLine;
    QList<float > wmax;
    QList<float > wdw0;
};

#endif
