/*
 * mksign.c -- calculate some parameters for ...  *  
 */
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>
#include <xview/xview.h> 
#include <xview/xv_xrect.h>
#include <xview/panel.h>
#include <xview/openmenu.h>
#include <xview/notice.h>
#include <xview/canvas.h>
#include <xview/cms.h>
#include <xview/cursor.h>


#include <math.h>
#include <sys/stat.h>
#include <dirent.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#ifndef MAXPATHLEN
#include <sys/param.h>
#endif
#define	 MAX_X	225
#define	 MAX_Y	225  
#define   WHITE   0
#define   RED     1
#define   GREEN   2
#define   BLUE    3
#define   ORANGE  4
#define   AQUA    5
#define   PINK    6
#define   BLACK    7
#define   GRAY     8
#define   YELLOW   9
#define   BROWN    10
#define   APRICOT   11
#define   SEASHELL   12
#define   LIGHTSALMON  13


    GC gc;
    unsigned long *colors;
   
char SignFileName[MAXPATHLEN];
  char    *Program_Name;	
      Xv_opaque quit(Panel_item ,Event *); 

extern   void       azid_mod_ (float *,float *,float *,float *,float *,float *,float *,float *,float *);

     int		selected(Panel_item ,int ,Event *);
     int	toggle_selected(Panel_item ,unsigned ,Event *);
     int	toggle_selected_Dr(Panel_item ,unsigned ,Event *);

     int    Selected_Open_SignFile(Panel_item ,int ,Event *);
     Xv_opaque Get_OUT(Panel_item ,Event *);
int     ignore_line(FILE *) ;

         char *getfilename(char * );
     int Get_WFDicsDirectoryList(char *);    
     char **WFDicsDirectoryList = NULL; 

Xv_Cursor Cursor_Ptr,Cursor_Busy;   

    Frame	frame;
    Canvas		canvas;
extern Xv_Window Window1;
Pixmap background_pixmap;
    Panel       	panel;
    Frame       	subframe,subframe2;
    Menu		menu;
 void	event_proc(); 
 void repaint_proc();


     Panel panel1;
     Panel_item Choice_Station,Choice_Station_D,Choice_N2N,Choice_Draw;
     
     char str_choice_station[8] ="Empty " ;     
     char str_choice_N2N[7] ="Empty " ;
     int Choice_Station_Value = 0;
  
   int argca;
   char **argva;
 int main(int , char *[]);

 int main(int argc, char *argv[])
 {  
 
 static char stipple_bits[] = {0x55,0x55,0x55,0x55}; 
   static Xv_singlecolor cms_colors[] = {
          {255,255,255},
           {255,0,0},
           {0,255,0},
           {0,0,255},
           {250,165,0},
           {30,230,250},
           { 230, 30, 250 },       
           {0,0,0},
           {220,220,220},  

           {255,255,0},
           {188,143,143},
           {180,100,20},
           {255,245,238},
           {255,160,122},


   };
     Cms                cms;
XFontStruct       *font;
     Display           *display;
     XGCValues          gc_val;
     XID                xid;
  Xv_cmsdata   cms_data;
     int use_dynamic = FALSE;
/* For drawing  */

/* For drawing  */

         Panel_item choice;
    int i,N_WFDiscFiles;
 Xv_singlecolor fg;
 Xv_singlecolor bg;
 fg.red = 250, fg.green = 230, fg.blue = 20;
 bg.red = 180, bg.green = 100, bg.blue = 20;  
    argca = argc;
    argva = argv; 
    Program_Name = argv[0];
 

    xv_init(XV_INIT_ARGC_PTR_ARGV, &argc, argv, NULL);
   
      WFDicsDirectoryList = NULL;

cms = xv_create(NULL, CMS,
         /*        CMS_CONTROL_CMS,TRUE,
                 CMS_SIZE,  CMS_CONTROL_COLORS +   11,*/
                 CMS_SIZE, 14,
                 CMS_TYPE,    use_dynamic ? XV_DYNAMIC_CMS : XV_STATIC_CMS,
                 CMS_COLORS,  cms_colors,
               NULL);


       frame = xv_create(XV_NULL, FRAME, 
       
	FRAME_LABEL,		"Prepare Sign File",
	XV_WIDTH,		400,
	XV_HEIGHT,		100, 
	FRAME_SHOW_FOOTER,	TRUE,
   /* FRAME_BACKGROUND_COLOR,&bg,
        FRAME_FOREGROUND_COLOR,&fg,*/
        FRAME_INHERIT_COLORS,TRUE,
   
	NULL);

Cursor_Busy = xv_create(NULL,CURSOR,
             CURSOR_SRC_CHAR, OLC_BUSY_PTR,
   NULL);
Cursor_Ptr  = xv_create(NULL,CURSOR,
             CURSOR_SRC_CHAR,OLC_BASIC_PTR,
   NULL);





    panel = xv_create(frame, PANEL, 

          NULL);
   xv_set(canvas_paint_window(panel), NULL);
  
 
    xv_create(panel, PANEL_BUTTON,
	PANEL_LABEL_STRING,     "Quit",
        	PANEL_NOTIFY_PROC,      quit,
	PANEL_CLIENT_DATA,	frame,
  	NULL);
argv[1] = ( argc > 1 ? argv[1] : ".");
     N_WFDiscFiles =   Get_WFDicsDirectoryList( argc > 1 ? argv[1] : "."); 
if (N_WFDiscFiles == 0) exit(1);

   choice = (Panel)xv_create(panel, PANEL_CHOICE,
           PANEL_DISPLAY_LEVEL,	PANEL_CURRENT,
           PANEL_LABEL_STRING,     "SignFile",
           PANEL_NOTIFY_PROC,      Selected_Open_SignFile,
           PANEL_CLIENT_DATA,	frame,
           NULL);
   for (i = 0; i < N_WFDiscFiles; i++) 
          xv_set(choice,
          PANEL_CHOICE_STRING,i,WFDicsDirectoryList[i],
          NULL);
 xv_create(panel, PANEL_BUTTON,
	PANEL_LABEL_STRING,     "Get Out",
       	PANEL_NOTIFY_PROC,      Get_OUT,
	PANEL_CLIENT_DATA,	frame,
  	NULL);


  xv_main_loop(frame);
  
}


int 
selected(Panel_item item,int value,Event *event)
{
    char buf[32];
    Frame frame = xv_get(item, PANEL_CLIENT_DATA);
    if (event_id(event) == MS_LEFT) {
	sprintf(buf, "\"%s\"\" selected",
	    xv_get(item, PANEL_CHOICE_STRING, panel_get_value(item)));
	xv_set(frame, FRAME_RIGHT_FOOTER, buf, NULL);
	return XV_OK;
    }
    return XV_ERROR;
}

int
numeric_text(Panel_item item,Event *event)
{
    char buf[32];

    Frame frame = xv_get(item, PANEL_CLIENT_DATA);


    sprintf(buf, "\"%s\" set to %d",
       (char *)xv_get(item, PANEL_LABEL_STRING), (int)xv_get(item, PANEL_VALUE));
    xv_set(frame, FRAME_RIGHT_FOOTER, buf, NULL);
    return PANEL_NEXT;
}

Xv_opaque quit(Panel_item item,Event *event)
{
    Panel 	panel = xv_get(item, PANEL_PARENT_PANEL);
    Frame 	frame = xv_get(panel,XV_OWNER);
    int 	result;

    if (event_id(event) == MS_LEFT)
	{
	result = notice_prompt(panel,   NULL,
                 NOTICE_FOCUS_XY,	event_x(event),event_y(event),
		 NOTICE_MESSAGE_STRINGS,"Confirm Quit?", NULL,
                 NOTICE_BUTTON_YES,	"Yes",
	         NOTICE_BUTTON_NO,	"No",
                 NULL);

        if (result == NOTICE_YES) {
         /*  xv_destroy_safe(subframe); */
	   xv_destroy_safe(frame);
	   }
	}
  return 0;
}

int    Selected_Open_SignFile(Panel_item item,int value,Event *event)
{
    char buf[MAXPATHLEN];
    char buf1[MAXPATHLEN];
    int i,k,q,j; 
    char sta_chan[32]; 
    Frame frame = xv_get(item, PANEL_CLIENT_DATA);
Xv_Window Wind;
    if (event_id(event) == MS_LEFT) {


 strcpy(buf1,argca > 1 ? argva[1] : ".");
 strcat(buf1,"/");
 strcat(buf1,(const char *)xv_get(item, PANEL_CHOICE_STRING,       panel_get_value(item)) );
 
   sprintf(buf, " \"%s\" selected",buf1);




  	xv_set(frame, FRAME_RIGHT_FOOTER, buf, NULL);
strcpy(SignFileName,buf1);  
    printf("\nInfo: %s: SignFile => %s\n",argva[0],buf);
      fflush(stdout);
 fprintf(stderr,"Debug: %s(Selected_Open_SignFile) : Return (XV_OK)\n",
      Program_Name);




	return XV_OK;
    }
    return XV_ERROR;
}


int Get_WFDicsDirectoryList(char *DirName)

{
 DIR              *dirp;
 struct dirent    *dp;
 struct stat       s_buf;
  int cnt  =0;
int j;
 char * ptr; 
 char * p;

      if (WFDicsDirectoryList != NULL)   free (WFDicsDirectoryList);
   WFDicsDirectoryList = malloc (sizeof(char*)*2) ; 
   WFDicsDirectoryList[0] = malloc(sizeof(char) * MAXPATHLEN);
   

  if (stat(DirName, &s_buf) == -1 || !(s_buf.st_mode & S_IREAD))
{ strcpy (WFDicsDirectoryList[0],"System error. Try again or Quit") ;  return 1;   } 
if (s_buf.st_mode & S_IFDIR )    {
     if (!(dirp = opendir(DirName))) 
          { strcpy (WFDicsDirectoryList[0],"Can't open Directory") ;  return 1;   }
     while  (dp = readdir(dirp) )   
        if (strcmp(dp->d_name, ".") && strcmp(dp->d_name, "..")) {
        ptr = getfilename(dp->d_name); 
     if ( ( p = strrchr(ptr,'.')) != NULL )
              if ( !strcmp(p,".bul") || !strcmp(p,".BUL")) {
   /* Debug Prn      printf("Get_WFDicsDirectoryList:  %s\n",ptr);
    Debug Prn      fflush(stdout); 
  */
      cnt++;
         }
     }
 
     closedir(dirp);
 }  
 /* Debug Prn       printf("Get_WFDicsDirectoryList: NFiles: %d\n",cnt);
  Debug Prn       fflush(stdout); 
*/
   if (cnt == 0)   
   { strcpy (WFDicsDirectoryList[0],"Can't find Bulletin File") ; 
  fprintf (stderr,"Can't find Bulletin File in the directory\n'%s'\n",argva[1]);

    return 0;   }
   
     
   
if (s_buf.st_mode & S_IFDIR )    {
     if (!(dirp = opendir(DirName))) 
          { strcpy (WFDicsDirectoryList[0],"Can't open Directory") ;  return 0;   }
     
   free ( WFDicsDirectoryList );
   WFDicsDirectoryList = malloc (sizeof(char *)  * cnt); 
   for (j = 0;j< cnt;j++)
   WFDicsDirectoryList[j] = malloc (sizeof(char ) * MAXPATHLEN);
     cnt = 0;
     while  (dp = readdir(dirp) )   
        if (strcmp(dp->d_name, ".") && strcmp(dp->d_name, "..")) {
        ptr = getfilename(dp->d_name); 
     
                       if ( ( p = strrchr(ptr,'.')) != NULL )
              if ( !strcmp(p,".bul") || !strcmp(p,".BUL")) {
                       strcpy(WFDicsDirectoryList[cnt],ptr);
 /* Debug Prn          printf("Get_WFDicsDirectoryList:  %s\n",WFDicsDirectoryList[cnt]);
  Debug Prn          fflush(stdout); 
*/
                       cnt++;
                    }
     }
 
     closedir(dirp);
 }  

 /* Debug Prn       printf("Get_WFDicsDirectoryList: %d\n",cnt);
  Debug Prn       fflush(stdout);  
*/
return cnt;
}

char *getfilename(char * path)

{
char *p;
 if ( p = rindex(path,'/'))
    p++;
 else 
   p = path;
   
 return strcpy((char *)malloc(strlen(p) + 1),p);
}



 
Xv_opaque Get_OUT(Panel_item item,Event *event)
{
    Panel 	panel = xv_get(item, PANEL_PARENT_PANEL);
    Frame 	frame = xv_get(panel,XV_OWNER);
    int 	result;
 	FILE	*in;
 	
        FILE    *out;
        char str1[512];
            int len;
            long N_Pdefile = 0,N_InpFile = 0;
            long i,j,k;
            char s1[250],s2[250];
            char *ptr,*ptr1;
             char **Inp_File;
    if (event_id(event) == MS_LEFT)
	{
/*
	result = notice_prompt(panel,   NULL,
                 NOTICE_FOCUS_XY,	event_x(event),event_y(event),
		 NOTICE_MESSAGE_STRINGS,"Confirm Quit?", NULL,
                 NOTICE_BUTTON_YES,	"Yes",
	         NOTICE_BUTTON_NO,	"No",
                 NULL);

        if (result == NOTICE_YES) {
           xv_destroy_safe(subframe);
	   xv_destroy_safe(frame);
	   }
*/




fprintf(stderr,"Debug: %s(Get_OUT) : Start \n",
      Program_Name);

        if( (in = fopen(SignFileName,"r")) == NULL) { 
              fprintf(stderr,"Modul Get_OUT: cannot open file_in %s\n",
              SignFileName); 
               return 1;  } 


       

  

       
       while ( !ignore_line(in)  ) N_InpFile++; 

        printf("\nInfo: %s:  N_inp = %ld\n", 
                Program_Name,N_InpFile);     
        fflush(stdout);
        fclose (in) ; 
        if( (in = fopen(SignFileName,"r")) == NULL) { 

              fprintf(stderr,"Modul Get_OUT: cannot open file_in %s\n",
              SignFileName); 
               return 4;  } 



        

   Inp_File = malloc (sizeof(char *)  * N_InpFile); 
   


     for (i = 0; i < N_InpFile; i++){
         fgets(s1,250,in); len = strlen(s1);
         Inp_File[i] = malloc (sizeof(char ) * (len + 1));
         strcpy (Inp_File[i],s1);
}


 fclose (in) ; 

do {
int indbool,N_EarthQuake,I_EarthQuake,k,q;
char i_1[20],i_2[20],i_3[20],j_3[20];
char lat_s[20],lon_s[20],dep_s[20];
float lat,lon,dep,slat,slon,ss;
int yy,mm,dd,hh,min;
 float del,dis,azfr,azto,err_slat,Az,a90_x;
 float delta,aztost;
 char Signed[10],StrNQuake[10];
float Rad = (float)((float)4.*(float)atan(1.)/(float)180.);
float Deg = (float)180./( (float)4.*(float)atan(1.) );
int *B_NQuake;
/*   START WRITING OUT FILE     ***********************************************/
N_EarthQuake = 0;
for (i = 0; i < N_InpFile; i++) {
 
 indbool = 0;

 for (j = 0; j < 8; j++) if (!(isdigit(Inp_File[i][j])  || Inp_File[i][j] == ' ')) indbool = 1;
 if (indbool == 0) N_EarthQuake++;
}

B_NQuake = malloc (sizeof(int)  * (N_EarthQuake+1)); 

 k = 0;
for (i = 0; i < N_InpFile; i++) {
 
 indbool = 0;

 for (j = 0; j < 8; j++) if (!(isdigit(Inp_File[i][j])  || Inp_File[i][j] == ' ')) indbool = 1;
 if (indbool == 0) B_NQuake[k++] = i;
}
B_NQuake[N_EarthQuake] = N_InpFile;
/*
                         fprintf(stderr,"RRR  :> \n");
                          for(i = 0; i <= N_EarthQuake; i++) 
   fprintf(stderr,"N(%d) = %d\n",i,B_NQuake[i]);
                         fprintf(stderr,"\n");
*/
N_EarthQuake /=2;
fprintf(stderr,"Info: N_EarthQuake = %d\n",N_EarthQuake);
   k = -1;
   for (I_EarthQuake = 0; I_EarthQuake < N_EarthQuake; I_EarthQuake++) { 

k++;
  sscanf (Inp_File[k++],"%s",str1); 

 sscanf (Inp_File[k++],"%d%d%d%d%d%f%f%f%f",&yy,&mm,&dd,&hh,&min,&ss,&lat,&lon,&dep);

sprintf(str1,"%d:%d:%d__%d:%d:%d",mm,dd,yy,hh,min,(int)ss);

strcat(str1,".polarity.ori");

fprintf(stderr,"Info: Name_Out_file(%d) = '%s'\n\n",I_EarthQuake,str1);

      if( (out = fopen(str1,"w")) == NULL) { 
            fprintf(stderr,"Modul Get_OUT: cannot open file_out %s\n",
            str1); 
            return 2;  } 

/*   START WRITING OUT FILE     ***********************************************/




 
        printf("\nInfo: %s: Event:> Y = %d M = %d D = %d H = %d M = %d S = %6.3f Lat = %g Lon = %g Dep = %g\n", 
                Program_Name,yy,mm,dd,hh,min,ss,lat,lon,dep);   
k++;  

 /*  
  OUT
c===============================================================================
  88  12  07    07  45  44.87   40.974   44.246  h=10  M=5.9    First Aftershock
     40.87     44.246    10.00

mgr  +   21.78  277
dui  +   22.34  282

*/ 

/*fprintf(out,"%s\n Hi!\n %e %e %e\n\n", 
"c===========================================",
lat,lon,dep ); */

lat   *= Rad;
lon   *= Rad;   
    /* for (i = 2; i < N_InpFile; i++){ */
fprintf(stderr,"Info: Number of Stations:> = %d\n",(B_NQuake[I_EarthQuake*2 + 2] - 1)-k);
q=k;
    for (i = k; i< B_NQuake[I_EarthQuake*2 + 2] - 1; i++) {
     sscanf(Inp_File[i],"%s%s",i_1,i_3);
     sscanf(Inp_File[i] + 19,"%f%f",&Az,&a90_x);  a90_x = (float)90.0 - a90_x; 
k++;
    
   strcpy(Signed,"0.0");


   if ( strchr (i_3,'c')  )strcpy(Signed," 1.0");
   if ( strchr (i_3,'+')  )strcpy(Signed," 1.0");
   if ( strchr (i_3,'d')  )strcpy(Signed,"-1.0");
   if ( strchr (i_3,'-')  )strcpy(Signed,"-1.0");
 fprintf(stderr,"Info: %3d %s %s %f %f\n",i-q + 1,i_1,i_3,Az,a90_x);
 fprintf (out,"%7.3f % 7.3f %s\n",
 Az,a90_x,Signed);      


 
       


  }
 
fclose(out); 

/*  k = k + B_NQuake[I_EarthQuake*2 + 2] - 1;  */

                           } /* I_EarthQuake   */
   }while(0);


}
 fprintf(stderr,"Debug: %s(Get_OUT) : Return (0)\n",
      Program_Name);

  return 0;

}


int     ignore_line(FILE *in) 
{ 
        char    string[256]; 
 
        if(fgets(string,250,in) == NULL)     /* nothing there        */ 
                return(-1); 
        return(0);                      /* there was something  */ 
} 
