czzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz
	Subroutine obscal(z0,m00,strike,dip,slip,ang_dc)
czzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz
c-----------------------------------------------------------------------
c       Program calculates amplitude spectrum of displacements in 
c	'krec' points on the free surface, due to Love and (or) 
c	Rayleigh waves, in moment tensor (DC+explosion) approximation 
c	using given values characterising moment tensor and depth, 
c	and given in 'momres.inp' file values characterising media and
c	spectral intervals.
c       It writes these spectra as well as observed amplitude spectra
c	in files.
c       Nrecorders(L+R)*Nw <= 900.
c	'krec' <= 45.
c	Nw<=18.
c-----------------------------------------------------------------------
        common/d/  a(100),b(100),rho(100),d(100)
        common/o/  c(128,3),t(128),ratio(128,3)
        common/c/nmax,mmax,kmax,idrop,iedit,ndiv,mode,fact
        common/new/ t1,dt,c1,dc,lstop,iq,imax(10)
        common/rar/ depth(100),amprfi(100),ampz(100),strz(100),
     *  strrfi(100),mmm
        common/rar1/ dcda,dcdb,dcdr,dwx,g1(100),g2(100)
        common/rco/ ccc,cvar,ugr,wvno,rat,arle
        common/rco1/ sumi0,sumi1,sumi2,sumi3,flagr
        common/deriv/ nderiv,ndpth,dpth(1),dspz(1),dsprfi(1),
     *  drvz(4,1),drvrfi(4,1)
        real*4 y1(1800),gl(6)
        real*4 mode2(2,45)
        real*4 un1(3),un2(3),m00
        real*8 dcda(100),dcdb(100),dcdr(100),dwx(100)
        real*8 ad(100),bd(100),rhod(100),dd(100)
        character*7 fname(2,45,3),chr
        character*1 fn1(2),fn4(3)
        character*2 fn2(45)
        character*3 fn3
	character*7 calname,obsname
        complex gr1(3,3,3),gr1_ex(3,3,3),rc1,rc2,rc3
        dimension gl0(6),amatr(1800,6),y(900)
	dimension vect_ex(1800)
        dimension a1(100,46),b1(100,46),rho1(100,46),d1(100,46),
     *  mmax1(46),ndiv1(46),mode1(2,45),mode11(2,45,18),c11(46),
     *  dc1(46),fact1(46),dist(45),dist0(45),fi(45),fi0(45),ncomp(2,45),
     *  wmxrec(2,45,3),wmnrec(2,45,3),nstr(45),crec(45),nfile(2,45,3),
     *  mode0(2),mode01(2),wmxsor(2,3),wmnsor(2,3),istart(45)
        real*4 cs(3),ugrs(3),sumi0s(3),vzs(3),vrfs(3),dvzs(3),
     *  dvrfs(3),cr(3),ugrr(3),sumi0r(3),vrr(3)
	real*4 vzs_ex(3),vrfs_ex(3),dvzs_ex(3),dvrfs_ex(3)
        dimension numeq(2,18,3,45)
	real*4 com_spe(2,2,3,45,18),caver0(2,3,45,18)
	integer norb(45),korb
c	ORBIT
c--------------------------------------------------------------------
c       12,12,6 - dimensions in terms of of slip, strike and dip
c       4 - four solutions, equivalent with respect to amplitudes
c--------------------------------------------------------------------
75      format(1x,///5x,i2,7x,i3,2(7x,f6.0),2(12x,i2))
76      format(1x,/////i3)
11      format(1x//2(6x,i3,2x))
44      format(1x,/(4f10.4))
55      format(10x,3f10.4)
12      format(5x,f3.0)
111     format(2(5x,f6.0,2x))
c-----------------------------------------------------------------------
c	m00 is given in n*m, in the program it is measured in dn*sm*e-20
c-----------------------------------------------------------------------
	m00=m00*1.e-13
        pi2=6.283184
        fn1(1)='l'
        fn1(2)='r'
        fn3='mod'
        fn4(1)='1'
        fn4(2)='2'
        fn4(3)='3'
        fn2(1)='01'
        fn2(2)='02'
        fn2(3)='03'
        fn2(4)='04'
        fn2(5)='05'
        fn2(6)='06'
        fn2(7)='07'
        fn2(8)='08'
        fn2(9)='09'
        fn2(10)='10'
        fn2(11)='11'
        fn2(12)='12'
        fn2(13)='13'
        fn2(14)='14'
        fn2(15)='15'
        fn2(16)='16'
        fn2(17)='17'
        fn2(18)='18'
        fn2(19)='19'
        fn2(20)='20'
        fn2(21)='21'
        fn2(22)='22'
        fn2(23)='23'
        fn2(24)='24'
        fn2(25)='25'
        fn2(26)='26'
        fn2(27)='27'
        fn2(28)='28'
        fn2(29)='29'
        fn2(30)='30'
        fn2(31)='31'
        fn2(32)='32'
        fn2(33)='33'
        fn2(34)='34'
        fn2(35)='35'
        fn2(36)='36'
        fn2(37)='37'
        fn2(38)='38'
        fn2(39)='39'
        fn2(40)='40'
        fn2(41)='41'
        fn2(42)='42'
        fn2(43)='43'
        fn2(44)='44'
        fn2(45)='45'
        l=9
                                do 50 i=1,2
                                do 50 j=1,45
                                do 50 k=1,3
        chr(1:1)=fn1(i)
        chr(2:3)=fn2(j)
        chr(4:6)=fn3
        chr(7:7)=fn4(k)
        fname(i,j,k)=chr
        l=l+1
        nfile(i,j,k)=l
        wmxrec(i,j,k)=0.
        wmnrec(i,j,k)=0.
c-----------------------------------------------------------------------
c       fname(i,j,k), nfile(i,j,k) - file name and file number for
c       Love (i=1) or Rayleigh (i=2) mode number k, recorder number j.
c-----------------------------------------------------------------------
50                                      continue
        open(1,file='momres.inp')
        open(2,file='list.err')
c----------------------------------------------------------------------
c       Reading of input data for surface waves parameters calculations.
c----------------------------------------------------------------------
        read(1,75)kstr,kmax,wmax,dw,mode01(1),mode01(2)

        mode0(1)=mode01(1)
        mode0(2)=mode01(2)
c----------------------------------------------------------------------
c       kstr - number of structures; kmax - max number of frequencies;
c       wmax - max frequency; dw - frequency step; mode0(i) - max number
c       of Love (i=1) and Rayleigh (i=2) modes.
c----------------------------------------------------------------------
        k=mode0(1)
        read(1,121)(wmxsor(1,i),wmnsor(1,i),i=1,k)

        k=mode0(2)
        read(1,121)(wmxsor(2,i),wmnsor(2,i),i=1,k)
121     format(1x,//6f6.0)
c----------------------------------------------------------------------
c       wmnsor(j,i), wmxsor(j,i) - min and max frequency with respect to
c       all recorders for i-th Love (j=1) and Rayleigh (j=2) mode.
c----------------------------------------------------------------------
	read(1,*)
	read(1,*)
                                do 14 k=1,kstr
c----------------------------------------------------------------------
c       k=1 - source-structure
c----------------------------------------------------------------------
        read(1,11)mmax1(k),ndiv1(k)
c----------------------------------------------------------------------
c       mmax1 - number of layers to be read in, including halfspace;
c       ndiv1 - number of subdivisions for one layer;
c----------------------------------------------------------------------
        l=mmax1(k)-1
        read(1,44)(d1(i,k),a1(i,k),b1(i,k),rho1(i,k),i=1,l)
c----------------------------------------------------------------------
c       d1 - thicness of layer in kilometers,
c       a1 - compressional wave velocity in km/sec,
c       b1 - transvers wave velocity in km/sec,
c       rho1 - density in gm/sm**3.
c----------------------------------------------------------------------
        l=l+1
        read(1,55)a1(l,k),b1(l,k),rho1(l,k)
        d1(l,k)=0.0
        read(1,12)fact1(k)
c----------------------------------------------------------------------
c       fact1 - number of wavelenghts below first layer wher phase
c       velocity is less than shear velocity that we may consider
c       to be effectiv halfspace.
c----------------------------------------------------------------------
                        if(fact1(k)) 100,100,101
100     fact1(k)=4.0
101                                     continue
        read(1,111)c11(k),dc1(k)
c----------------------------------------------------------------------
c       c11 - initial phase velocity guess;
c       dc1 - phase velocity increment.
c----------------------------------------------------------------------
14                                      continue
c-----------------------------------------------------------------------
c       Reading of the number of recorders, recorders coordinates,
c       number of modes and corresponding structures numbers.
c-----------------------------------------------------------------------
        read(1,76)krec
c-----------------------------------------------------------------------
c       krec - number of recorders
c-----------------------------------------------------------------------
c        read(1,77)(dist0(i),fi0(i),mode1(1,i),ncomp(1,i),mode1(2,i),
c     *  ncomp(2,i),nstr(i),i=1,krec)
        read(1,77)(dist0(i),fi0(i),mode1(1,i),ncomp(1,i),mode1(2,i),
     *  ncomp(2,i),nstr(i),norb(i),i=1,krec)
c	ORBIT
c--------------------------------------------------------------------
c-----------------------------------------------------------------------
c       dist0 - length of the ray (initial epicentre-receiver);
c       fi0 - azimuth of initial epicentre-receiver direction;
c       mode1(k,i) - number of Love (k=1) and Rayleigh (k=2) modes;
c       ncomp(k,i) - number of the component of displacements
c       (1-z,2-x,3-y) in Love (k=1) and Rayleigh (k=2) modes;
c       nstr - number of corresponding structure.
c-----------------------------------------------------------------------
77      format(1x,/(2f8.0,5i5,i6))
                                do 78 i=1,krec
        dist(i)=dist0(i)
        fi(i)=fi0(i)
78                                      continue
        read(1,22)(((wmxrec(i,j,k),wmnrec(i,j,k),k=1,3),i=1,2),j=1,krec)
c-----------------------------------------------------------------------
c       wmxrec(i,j,k),wmnrec(i,j,k) - max and min w for k-th Love (i=1)
c       or Rayleigh (i=2) mode on recorder number j.
c-----------------------------------------------------------------------
                                do 79 i=1,2
                                do 79 j=1,krec
        mode2(i,j)=mode1(i,j)
79                                      continue
22      format(1x,////(12f6.0))
	slip=180.-slip
        close(1)
c7773    format(1x,/2f5.0,i5)
        iwmax=kmax
c---------------------------------------------------------------
                                do 791 i=1,2
                                do 791 j=1,18
                                do 791 k=1,3
                                do 791 l=1,45
        numeq(i,j,k,l)=99999
791                                     continue
		do 8000 i=1,2
		do 8000 j=1,3
		do 8000 k=1,45
	chr=fname(i,k,j)
	open(11,file=chr,status='old',err=8001)
	read(11,*)
		do 8003 l=1,18
        w=wmax-dw*(l-1)
        r3=wmnrec(i,k,j)
        r4=wmxrec(i,k,j)
                        if(w.lt.r3) go to 8002
			if(w.gt.r4) go to 8003
	read(11,*)com_spe(1,i,j,k,l),com_spe(2,i,j,k,l),caver0(i,j,k,l)
8003		continue
8002		continue
	close(11)
8001		continue
8000		continue
	nvar=0
        nequ=0
        dpth(1)=z0
        ndpth=1
c-----------------------------------------------------------------------
c       L,R-cycle
c-----------------------------------------------------------------------
                                do 9999 ifunc=1,2 
                                                go to (10,20),ifunc
10                      if(mode0(1).le.0)       go to 9999
                                                go to 30
20                      if(mode0(2).le.0)       go to 9999
30                                      continue
        cs(1)=c11(1)
                                do 7770 j=1,krec
        mode1(ifunc,j)=mode2(ifunc,j)
        jj=nstr(j)
        crec(j)=c11(jj)
	istart(j)=0
7770                                    continue 
        kmax=1
                                do 8888 iw=1,iwmax
        w=wmax-dw*(iw-1)
        t(1)=pi2/w
c-----------------------------------------------------------------------
c       SURFACE for the source-structure (all modes)
c-----------------------------------------------------------------------
        number=0
        numbel=0
        iedit=2
        mmax=mmax1(1)
        nmax=mmax
        ndiv=ndiv1(1)
        mode=mode0(ifunc)
                                do 8880 i=1,mmax
        dd(i)=d1(i,1)
        ad(i)=a1(i,1)
        bd(i)=b1(i,1)
        rhod(i)=rho1(i,1)
8880                                    continue
        call flat(dd,rhod,ad,bd,mmax,ifunc)
                                do 9880 i=1,mmax
        d(i)=dd(i)
        a(i)=ad(i)
        b(i)=bd(i)
        rho(i)=rhod(i)
9880                                    continue
        fact=fact1(1)
        dc=dc1(1)
        c1=cs(1)-0.1
                        if(iw.eq.1) c1=c11(1)
        call disper(ifunc,ierr)
                                do 8881 i=1,mode
        j=mode-i+1
        l=imax(j)
                        if(l.eq.0) mode0(ifunc)=mode0(ifunc)-1
8881                                    continue
        mode=mode0(ifunc)
        nderiv=1
                                do 8884 iq=1,mode
        r1=wmnsor(ifunc,iq)
        r2=wmxsor(ifunc,iq)
c----------------------------------------------------------------------
c       wmnsor(j,i), wmxsor(j,i) - min and max frequency with respect to
c       all recorders for i-th Love (j=1) and Rayleigh (j=2) mode.
c----------------------------------------------------------------------
                        if(w.lt.r1.or.w.gt.r2)  go to 8884
                                                goto (7781,7782),ifunc
7781                                    continue
        number=-1
        call leigen(numbel,1,iq)
        numbel=numbel+1
                                                go to 8882
7782                                    continue
        call reigen(number,1,iq)
                        if(number.eq.-1) number=0
        number=number+1
8882                                    continue
        cs(iq)=ccc
        ugrs(iq)=ugr
        sumi0s(iq)=sumi0
        vrfs(iq)=dsprfi(1)
        vzs(iq)=dspz(1)
        dvrfs(iq)=drvrfi(1,1)
        dvzs(iq)=drvz(1,1)
c-----------------------------------------------------------------------
c       will be used if ifunc=2 and nstr(1)=1
c-----------------------------------------------------------------------
        vrr(iq)=amprfi(1)
8884                                    continue
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
c-----------------------------------------------------------------------
c	Calculation of eigen functions and their derivatives at free 
c	surface - for explosion estimate
c-----------------------------------------------------------------------
			if(ifunc.eq.1) go to 2222
        dpth(1)=0.
        number=0
        iedit=2
        mmax=mmax1(1)
        nmax=mmax
        ndiv=ndiv1(1)
        mode=mode0(2)
                                do 880 i=1,mmax
        dd(i)=d1(i,1)
        ad(i)=a1(i,1)
        bd(i)=b1(i,1)
        rhod(i)=rho1(i,1)
880                                    continue
        call flat(dd,rhod,ad,bd,mmax,2)
                                do 988 i=1,mmax
        d(i)=dd(i)
        a(i)=ad(i)
        b(i)=bd(i)
        rho(i)=rhod(i)
988                                    continue
        fact=fact1(1)
        dc=dc1(1)
        c1=cs(1)-0.1
                        if(iw.eq.1) c1=c11(1)
        call disper(2,ierr)
        mode=mode0(2)
        nderiv=1
                                do 884 iq=1,mode
        r1=wmnsor(ifunc,iq)
        r2=wmxsor(ifunc,iq)
c----------------------------------------------------------------------
c       wmnsor(j,i), wmxsor(j,i) - min and max frequency with respect to
c       all recorders for i-th Love (j=1) and Rayleigh (j=2) mode.
c----------------------------------------------------------------------
                        if(w.lt.r1.or.w.gt.r2)  go to 884
        call reigen(number,1,iq)
c                        if(number.eq.-1) number=0
        number=number+1
        vrfs_ex(iq)=dsprfi(1)
        vzs_ex(iq)=dspz(1)
        dvrfs_ex(iq)=drvrfi(1,1)
        dvzs_ex(iq)=drvz(1,1)
884				continue 
        dpth(1)=z0
2222			continue 
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
c-----------------------------------------------------------------------
c       recorders-cycle
c-----------------------------------------------------------------------
                                do 8887 nrec=1,krec
        mode=mode1(ifunc,nrec)
                        if(mode.le.0)           go to 8887
        dist1=dist(nrec)
        fi1=fi(nrec)
c--------------------------------------------------------------------
	korb=norb(nrec)
c	ORBIT
c--------------------------------------------------------------------
        i=nrec-1
        j=1
                        if(i.ne.0) j=nstr(i)
                        if(nstr(nrec).ne.j)     go to 8885
        l=mode0(ifunc)
                        if(i.ne.0) l=mode1(ifunc,i)
                        if(mode.gt.l)           go to 8885
                                do 8874 iq=1,mode
        r1=wmnsor(ifunc,iq)
        r2=wmxsor(ifunc,iq)
                        if(i.ne.0) r1=wmnrec(ifunc,i,iq)
                        if(i.ne.0) r2=wmxrec(ifunc,i,iq)
        r3=wmnrec(ifunc,nrec,iq)
        r4=wmxrec(ifunc,nrec,iq)
c-----------------------------------------------------------------------
c       wmxrec(i,j,k),wmnrec(i,j,k) - max and min w for k-th Love (i=1)
c       or Rayleigh (i=2) mode on recorder number j.
c-----------------------------------------------------------------------
                        if(w.lt.r3.or.w.gt.r4)  go to 8874
                        if(w.lt.r1.or.w.gt.r2)  go to 8885
8874                                    continue
                        if(i.ne.0)              go to 8886
                                do 8875 iq=1,mode
        cr(iq)=cs(iq)
        ugrr(iq)=ugrs(iq)
        sumi0r(iq)=sumi0s(iq)
8875                                    continue
                                                go to 8886
8885                                    continue
c-----------------------------------------------------------------------
c       SURFACE for the recorders-structures (all of modes)
c-----------------------------------------------------------------------
        number=0
        numbel=0
        iedit=1
        jstr=nstr(nrec)
        mmax=mmax1(jstr)
        nmax=mmax
        ndiv=ndiv1(jstr)
        mode=mode1(ifunc,nrec)
                                do 9990 i=1,mmax
        dd(i)=d1(i,jstr)
        ad(i)=a1(i,jstr)
        bd(i)=b1(i,jstr)
        rhod(i)=rho1(i,jstr)
9990                                    continue
        call flat(dd,rhod,ad,bd,mmax,ifunc)
                                do 8990 i=1,mmax
        d(i)=dd(i)
        a(i)=ad(i)
        b(i)=bd(i)
        rho(i)=rhod(i)
8990                                    continue
        fact=fact1(jstr)
        dc=dc1(jstr)
        c1=crec(nrec)-0.1
                        if(iw.eq.1.or.istart(nrec).lt.1) c1=c11(jstr)
        call disper(ifunc,ierr)
        i1=0
                                do 9991 i=1,mode
        j=mode-i+1
        l=imax(j)
                        if(l.gt.0)              go to 9991
        mode1(ifunc,nrec)=mode1(ifunc,nrec)-1
        i1=1
9991                                    continue
        mode=mode1(ifunc,nrec)
                                do 9993 iq=1,mode
        r3=wmnrec(ifunc,nrec,iq)
        r4=wmxrec(ifunc,nrec,iq)
                        if(w.lt.r3.or.w.gt.r4)  go to 9993
                                                goto (8871,8872),ifunc
8871                                    continue
        number=-1
        call leigen(numbel,1,iq)
        numbel=numbel+1
                                                go to 9992
8872                                    continue
        call reigen(number,1,iq)
                        if(number.eq.-1) number=0
        number=number+1
9992                                    continue
        cr(iq)=ccc
        ugrr(iq)=ugr
        sumi0r(iq)=sumi0
        vrr(iq)=amprfi(1)
c-----------------------------------------------------------------------
c       will be used as c1 at next w
c-----------------------------------------------------------------------
                        if(iq.eq.1)  then
	crec(nrec)=cr(1)
	istart(nrec)=istart(nrec)+1
	end if
9993                                    continue
8886                                    continue
                                do 9994 iq=1,mode
        r3=wmnrec(ifunc,nrec,iq)
        r4=wmxrec(ifunc,nrec,iq)
                        if(w.lt.r3.or.w.gt.r4)  go to 9994
        cs1=cs(iq)
        ugrs1=ugrs(iq)
        sum0s=sumi0s(iq)
        cr1=cr(iq)
        ugrr1=ugrr(iq)
        sum0r=sumi0r(iq)
        vrr1=vrr(iq)
        lr=ifunc-1
        vzs1=vzs(iq)
        vrfs1=vrfs(iq)
        dvzs1=dvzs(iq)
        dvrfs1=dvrfs(iq)
        l=nequ/2+1
	reu=com_spe(1,ifunc,iq,nrec,iw)
	aimu=com_spe(2,ifunc,iq,nrec,iw)
	caver=caver0(ifunc,iq,nrec,iw)
        r1=reu*reu+aimu*aimu
        y(l)=sqrt(r1)
                        if(caver.gt.1.0e-6)     go to 1111
        caver=cs1
1111                                    continue
c        call green1(cs1,ugrs1,sum0s,vzs1,vrfs1,dvzs1,dvrfs1,cr1,
c    *  ugrr1,sum0r,vrr1,lr,w,dist1,fi1,caver,gr1,ierr)
        call green1(cs1,ugrs1,sum0s,vzs1,vrfs1,dvzs1,dvrfs1,cr1,
     *  ugrr1,sum0r,vrr1,lr,w,dist1,fi1,caver,gr1,ierr,korb)
c	ORBIT
c-----------------------------------------------------------------------
c	Green1 for explosion 
c-----------------------------------------------------------------------
		if(ifunc.eq.2) then
	vzs1=vzs_ex(iq)
	vrfs1=vrfs_ex(iq)
        dvzs1=dvzs_ex(iq)
       	dvrfs1=dvrfs_ex(iq)
c        call green1(cs1,ugrs1,sum0s,vzs1,vrfs1,dvzs1,dvrfs1,cr1,
c     *  ugrr1,sum0r,vrr1,lr,w,dist1,fi1,caver,gr1_ex,ierr)
        call green1(cs1,ugrs1,sum0s,vzs1,vrfs1,dvzs1,dvrfs1,cr1,
     *  ugrr1,sum0r,vrr1,lr,w,dist1,fi1,caver,gr1_ex,ierr,korb)
c	ORBIT
c-----------------------------------------------------------------------
		end if
c-----------------------------------------------------------------------
c       The matrix for DC is amatr(1800,6), 
c	for explosion it is a vector vect_ex(1800), 
c	the vector of measured modulie is "y"
c       ( Nrecorders*Nmodes(L+R)*Nw <= 900 ),
c       DC moment tensor gl(i) :
c		{m(1,1);m(2,1);m(3,1);m(2,2);m(3,2);m(3,3)}.
c	Explosion moment tensor: Me*{1;0;0;1;0;1}
c-----------------------------------------------------------------------
        j=ncomp(ifunc,nrec)
        k2=1
                                do 3333 l=1,3
                                do 3333 k=l,3
        rl=l
        rk=k
        kk=rl/rk+1.1
        r1=kk
        rc1=gr1(j,k,l)+gr1(j,l,k)
        rc2=(0.,1.)*w*r1
        rc3=rc1/rc2
        r1=real(rc3)
        r2=aimag(rc3)
        k1=nequ+1
        amatr(k1,k2)=r1
        k1=k1+1
        amatr(k1,k2)=r2
        k2=k2+1
3333                                    continue
        k1=nequ+1
	vect_ex(k1)=0.
	vect_ex(k1+1)=0.
			if(ifunc.eq.2) then
	rc1=gr1_ex(j,1,1)+gr1_ex(j,2,2)+gr1_ex(j,3,3)
        rc2=(0.,1.)*w
	rc3=sqrt(2./3.)*rc1/rc2
        vect_ex(k1)=real(rc3)
        k1=k1+1
        vect_ex(k1)=aimag(rc3)
			end if
        numeq(ifunc,iw,iq,nrec)=nequ+1
        nequ=nequ+2
c-----------------------------------------------------------------------
c       end of modes-cycle
c-----------------------------------------------------------------------
9994                                    continue
        mode11(ifunc,nrec,iw)=mode1(ifunc,nrec)
c-----------------------------------------------------------------------
c       end of recorders-cycle
c-----------------------------------------------------------------------
8887                                    continue
c-----------------------------------------------------------------------
c       end of w-cycle
c-----------------------------------------------------------------------
8888                                    continue
c-----------------------------------------------------------------------
c       end of L,R-cycle
c-----------------------------------------------------------------------
9999                                    continue
        ngl=5
c-----------------------------------------------------------------------
c       Condition gl(1)=-gl(4)-gl(6) is accepted. 'amatr' is reducing
c       with respect to the 1-st column and gl(i) is reducing with 
c       respect to the 1-st component.
c-----------------------------------------------------------------------
                                do 4443 k=1,nequ
        amatr(k,4)=amatr(k,4)-amatr(k,1)
        amatr(k,6)=amatr(k,6)-amatr(k,1)
4443                                    continue
                                do 4444 k2=2,6
        k=k2-1
                                do 4444 k1=1,nequ
        amatr(k1,k)=amatr(k1,k2)
4444                                    continue
	ang_dc=ang_dc*pi2/360.	
	rsin=sin(ang_dc)
	rcos=cos(ang_dc)
        dip=dip*pi2/360.
        cosdp=cos(dip)
        sindp=sin(dip)
        un1(1)=cosdp
        strike=strike*pi2/360.
        cosst=cos(strike)
        sinst=sin(strike)
        un1(2)=sindp*sinst
        un1(3)=-sindp*cosst
        slip=slip*pi2/360.
        cossl=cos(slip)
        sinsl=sin(slip)
        un2(1)=sinsl*sindp
        un2(2)=cossl*cosst-sinsl*sinst*cosdp
        un2(3)=cossl*sinst+sinsl*cosst*cosdp
        gl0(1)=2.*un1(1)*un2(1)
        gl0(2)=un1(1)*un2(2)+un1(2)*un2(1)
        gl0(3)=un1(1)*un2(3)+un1(3)*un2(1)
        gl0(4)=2.*un1(2)*un2(2)
        gl0(5)=un1(2)*un2(3)+un1(3)*un2(2)
        gl0(6)=2.*un1(3)*un2(3)
                                do 21 i=1,ngl
        j=i+6-ngl
        gl(i)=gl0(j)
21                                      continue
        r6=pi2/2.
                                do 26 i=1,nequ,2
        k1=1+i/2
        l=i+1
        y1(i)=rsin*vect_ex(i)
        y1(l)=rsin*vect_ex(l)
                                do 25 j=1,ngl
        y1(i)=rcos*amatr(i,j)*gl(j)+y1(i)
        y1(l)=rcos*amatr(l,j)*gl(j)+y1(l)
25                                      continue
        r1=y1(i)*y1(i)+y1(l)*y1(l)
        r1=sqrt(r1)
        y1(k1)=r1*m00
26                                      continue
                                do 7971 i=1,2
                                do 7971 l=1,45
                                do 7971 k=1,3
	ll=0
                                do 7972 j=1,18
                        if(numeq(i,j,k,l).ne.99999) ll=1
7972                                    continue
			if(ll.eq.0) go to 7971
	obsname(1:1)=fn1(i)
	obsname(2:3)=fn2(l)
	obsname(4:4)='_'
	obsname(5:7)='obs'
	calname=obsname
	calname(5:7)='cal'
        open(11,file=obsname)
	open(12,file=calname)
                                do 7973 j=1,18
                        if(numeq(i,j,k,l).eq.99999) go to 7973
        ww=wmax-dw*(j-1)
        tt=pi2/ww
        ll=(numeq(i,j,k,l)+1)/2
	r1=tt
        write(11,*)r1,y(ll)
	write(12,*)r1,y1(ll)
7973                                    continue
	close(11)
	close(12)
7971                                    continue
        close(2)
                                                                RETURN
                                                                END
