//#include <iostream.h>
#include <QtGui>
#include "bulletin.h"
#include "default.h"
void StrRemoveBlank(char *str);
void StrRemoveBlank(char *str){
char* ptr;
 while ( ( ( ptr = strchr(str,' ') ) != 0 ) )  strcpy(ptr,ptr +1);
}
 
extern "C" { 
extern int  takeofvp_ (float *,float* ,long* ,float *,float *,
      char* ,long *,long *,char *);
//extern int  takeoff_(float *dep,float *delta,float* vpsource,float *take_off_ang,long *ierr,char *err_txt);

}
int Mchedr::ReadEpicentre(FILE *inbul){
   char line[256],lineHY[80],lineE[80];
   bool  indHY = false, indE = false;

      
	while ( !fgets( line, 256, inbul ) == 0) {
		   {   //printf( "####%s", line); 
		if (!strncmp(line, "HY" , 2)){ //printf( "####%s", line);
			strcpy(lineHY,line);
			indHY = true;}
		if (!strncmp(line, "E" , 1)) { //printf( "####%s", line); 
			strcpy(lineE,line);
		indE  = true;}
		if  (indHY == true && indE  == true) {
		GetEpicenterInfo(lineHY,lineE);
		 return ReadEpicentreComplete;
		}
 
		
 		} 
	}// end while  ( !fgets ....
		if (feof( inbul )) return EofFind;
		else	
    		return ErrorRead;
	 
}

Bulletin::Bulletin():itsNumberStation(0),itsNumberFirstMotion(0),indMaxDistance(0),
            indMinDistance(0) {}


int Bulletin::ReadStation(FILE *inbul){
   char line[256];
   bool indP = false;

      
	while ( !fgets( line, 256, inbul ) == 0) {
			GetStationInfo(line);
			indP = true;
	}// end while  ( !fgets( .....

		if (feof( inbul ) ) {
			if  (indP == true ) return ReadStationComplete;
			else
			return EofFind;
			}
		else	
    		return ErrorRead;

}


int Mchedr::GetEpicenterInfo(char *lineHY,char *lineE) {
	char *row = new char[strlen(lineHY) + strlen(lineHY) +1]; 
	char ch;char NS,EW;
	float lat,lon;
	strcpy(row,lineHY); 
	strcat(row,lineE);

	Epicentre* eipi = new Epicentre(row);

	sscanf(row+2,"%4d%2d%2d%c%2d%2d%5f%c%6f%c%c%7f%c%c%5f",
	&eipi->GetYear  (),
	&eipi->GetMonth (),
	&eipi->GetDay   (),&ch,
	&eipi->GetHour  (),
	&eipi->GetMinute(),
	&eipi->GetSec   (),&ch,
	&lat,&NS,&ch,
	&lon,&EW,&ch,
	&eipi->GetDepth ()
	);
if (NS == 'N') eipi->GetLat   () = lat; else eipi->GetLat   () = -lat;
if (EW == 'E') eipi->GetLon   () = lon; else eipi->GetLon   () = -lon;

	char *ptr = strchr(row,'\n') + 29;
	sscanf(ptr,"%3f",&eipi->GetMagMb ()); 

	strcpy( eipi->GetMbCode(),"mb");

	ptr = strchr(row,'\n') + 36;
	sscanf(ptr,"%3f",&eipi->GetMagMs ());
 
	strcpy(eipi->GetMsCode(),"Ms");
/*
fprintf(stderr,"Info: Epicetre:  %2.2d/%2.2d/%4d %2.2d:%2.2d:%5.2f %7.3f %8.3f %5.1f  \nInfo: Epicetre:  %3.1f '%s' %3.1f '%s'\n",
eipi->GetDay   (),
eipi->GetMonth (),
eipi->GetYear  (),
eipi->GetHour  (),
eipi->GetMinute(),
eipi->GetSec   (),
eipi->GetLat   (),
eipi->GetLon   (),
eipi->GetDepth (),

eipi->GetMagMb (),
eipi->GetMbCode(), 
eipi->GetMagMs (),
eipi->GetMsCode()
);
*/
	itsPtrOutEpicentre = eipi;

return 0;

}


int Mchedr::GetStationInfo(char *line){
//fprintf(stderr,"%s",line);
// 
if (!(strncmp(line,"P ",2) == 0 || strncmp(line,"p ",2) == 0 ))  return 0;
itsNumberStation++;

float indDistance;
	sscanf(line+32,"%6f",&indDistance);
if (indDistance > maxUseDistance) {indMaxDistance++;return 0;}
if (indDistance < minUseDistance) {indMinDistance++;return 0;}


	Station* sta = new Station(line);

	// sta->Show();

	sscanf(line+2,"%5c",
sta->GetStationCode ()); (sta->GetStationCode ())[5] = '\0';
	sscanf(line+7,"%8c",
sta->GetPhaseCode ()); (sta->GetPhaseCode ())[8] = '\0';

	sscanf(line+25,"%5f",
&sta->GetIscResidual ()); 

	sscanf(line+32,"%6f",
&sta->GetDistance ()); 

	sscanf(line+39,"%5f",
&sta->GetAzimuthToStation ()); 
int lenPhasecode= strlen(sta->GetPhaseCode ());

if (lenPhasecode > 1 ) {
char *ptr = sta->GetPhaseCode ();


while (*ptr != '\n') if ( *ptr != ' ') break;else ptr++;
	if(*ptr == 'e' || *ptr == 'i') sta->GetQuality() = *ptr; 
	else sta->GetQuality() = ' ';

ptr = sta->GetPhaseCode ();
int i;
for (i = lenPhasecode; i > 0; i-- ) if ( ptr[i-1] != ' ') break;

if(ptr[i-1] == 'c' || ptr[i-1] == 'd' || ptr[i-1] == '-' || ptr[i-1] == '+') sta->GetPolar() = ptr[i-1];
else sta->GetPolar() = ' ';
if (sta->GetPolar() == 'c')sta->GetPolar()='+';
if (sta->GetPolar() == 'd')sta->GetPolar()='-';

} 
else { sta->GetPolar () = ' ';  sta->GetQuality() = ' '; }

/*
fprintf(stderr,"st:'%s' pc:'%s' res: %5.1f d:%6.2f az: %5.1f q: '%c' p: '%c'\n",
sta->GetStationCode (),
sta->GetPhaseCode (),
sta->GetIscResidual (),
sta->GetDistance (),
sta->GetAzimuthToStation (),
sta->GetQuality (),
sta->GetPolar ()
);
*/




	    itsOutStationList.push_back(sta);


return 0;
};
int Bulletin::WriteFirstMotions(FILE *outbul,float depth,float vpsource) { 
/*
fprintf(outbul,"%s\n","c===============================================================================");

fprintf(outbul,"%4d  %2.2d  %2.2d    %2.2d  %2.2d  %5.2f %7.3f %8.3f  h=% 5.0f  %s=%3.1f %s=%3.1f\n",
itsPtrOutEpicentre->GetYear  (),
itsPtrOutEpicentre->GetMonth (),
itsPtrOutEpicentre->GetDay   (),
itsPtrOutEpicentre->GetHour  (),
itsPtrOutEpicentre->GetMinute(),
itsPtrOutEpicentre->GetSec   (),
itsPtrOutEpicentre->GetLat   (),
itsPtrOutEpicentre->GetLon   (),
itsPtrOutEpicentre->GetDepth (),

itsPtrOutEpicentre->GetMbCode(), 
itsPtrOutEpicentre->GetMagMb (),

itsPtrOutEpicentre->GetMsCode(),
itsPtrOutEpicentre->GetMagMs ()

);
fprintf(outbul," %7.3f %8.3f  %5.0f\n\n",
itsPtrOutEpicentre->GetLat   (),
itsPtrOutEpicentre->GetLon   (),
itsPtrOutEpicentre->GetDepth ()
);

*/
float takeof,azimuth,distance;
long errorcode;
char indChar;
int indPlus = 0;
int indMinus = 0;
int indNonPM = 0;

long  returnCode = 0;
char* returnStr = new char[128];
QString tblname = QString("%1").arg(rootPath());
tblname.append("/ref/ak135");

                      
char* modelname = new char[256];
strcpy(modelname,tblname.toAscii().data());
long len = strlen(modelname);

	for(itsItrOutStationList=itsOutStationList.begin(); 	
	itsItrOutStationList!=itsOutStationList.end(); 
	itsItrOutStationList++) {
indChar = (*itsItrOutStationList)->GetPolar();
if (indChar != ' ') {


azimuth = (*itsItrOutStationList)->GetAzimuthToStation();
distance = (*itsItrOutStationList)->GetDistance();
long n; 
//QMessageBox::critical(0,"Critical Error 0",QString("azimuth %1 distance %2 vpsource %3").arg(azimuth).arg(distance).arg(vpsource));
takeofvp_(&depth,&distance,&n,&takeof,&vpsource,modelname,&len,&returnCode,returnStr);
QString info = "";
if (returnCode == -1) {
if (strchr(returnStr,'@')) *strchr(returnStr,'@')= '\0'; else strcpy(returnStr,"Unknown error");
info += QString("\nKennet Table info: \"%1\"\n").arg(QString(returnStr));
info += QString("depth: %1 delta %2\n").arg(depth).arg(distance);

QMessageBox::critical(0,"Critical Error",info);
}
//takeoff_(&depth,&distance,&vpsource,&takeof,&ierr,err_txt);
  

if(indChar == '+') {
	fprintf(outbul,"%7.3f %7.3f  +1.0\n",azimuth,takeof);
indPlus++;
}
if(indChar == '-') {
	fprintf(outbul,"%7.3f %7.3f -1.0\n",azimuth,takeof);
indMinus++;
}
indNonPM++;
} // if ((*itsItrOutStationList)->GetPolar() != ' ')

	}

  return 0;
  }





Bulletin::~Bulletin(){
	for(itsItrOutStationList=itsOutStationList.begin(); 	
	itsItrOutStationList!=itsOutStationList.end(); 
	itsItrOutStationList++) 	delete (*itsItrOutStationList);

	itsOutStationList.clear();

delete itsPtrOutEpicentre;
}

int Bulletin::StatisticFMotion(FILE *outst){
	fprintf(outst,"\n Statistic of Primary Phase Records & First Motions:\n\n");
fprintf (outst,"Primary Phase Records:> %d \n",
itsNumberStation);

if (indMaxDistance > 0)
	fprintf(outst,"Station Records ( %d ) with Distance greater %6.2f were removed\n",indMaxDistance,
maxUseDistance );
if (indMinDistance > 0)
	fprintf(outst,"Station Records ( %d ) with Distance less %6.2f were removed\n",indMinDistance,
minUseDistance );

	list<StaticPhase * > phaseList;  
	list<StaticPhase * >::iterator itrPhaseList;


char searchStr[128];
char currentStr[128];
bool indBool = false;
StaticPhase* pStaticPhaase;
int i = 0;
char polar;
	for(itsItrOutStationList=itsOutStationList.begin(); 	
	itsItrOutStationList!=itsOutStationList.end(); 
	itsItrOutStationList++) {

	strcpy(searchStr,(*itsItrOutStationList)->GetPhaseCode());
	StrRemoveBlank(searchStr);
	indBool = false;

		if(!phaseList.empty())
        	for(itrPhaseList=phaseList.begin(); 	
		itrPhaseList!=phaseList.end(); itrPhaseList++)   {
		strcpy(currentStr,(*itrPhaseList)->GetPhaseName());
		StrRemoveBlank(currentStr);

	if (strlen(searchStr) == strlen(currentStr))
	if (strncmp(searchStr, currentStr,strlen(currentStr)) == 0) {
	  i = (*itrPhaseList)->GetNumberPhase(); i++;
	(*itrPhaseList)->GetNumberPhase() = i;
	indBool = true;
	} // searchStr == currentStr

		} // itrPhaseList
              if (indBool == false) {
polar = (*itsItrOutStationList)->GetPolar();
pStaticPhaase = new StaticPhase(searchStr,polar );
phaseList.push_back(pStaticPhaase);

}// (indBool == false)
             

} // itrPhaseList


int count = 0;
int MaxLen = 0;
int curLen;
int countPlus,countMinus,countPlusMinus;
countPlus = countMinus = countPlusMinus = 0;
		if(!phaseList.empty())
        	for(itrPhaseList=phaseList.begin(); 	
		itrPhaseList!=phaseList.end(); itrPhaseList++)   {
i = (*itrPhaseList)->GetNumberPhase();
		strcpy(currentStr,(*itrPhaseList)->GetPhaseName());
curLen = strlen(currentStr);
if (curLen > MaxLen) MaxLen = curLen; 
if ((*itrPhaseList)->GetPhaseCode() == '+') 
{  countPlus +=  i; countPlusMinus +=  i; }
if ((*itrPhaseList)->GetPhaseCode() == '-') 
{  countMinus +=  i; countPlusMinus +=  i; }
count += i;

} //itrPhaseList



	fprintf (outst,"Removed (Distance limits):>  %d Used:> %d\n", 
 indMinDistance + indMaxDistance,count);



	fprintf(outst,"\n NN   Phase Code           Num    Motion\n");

int curNum = 0;

		if(!phaseList.empty())
        	for(itrPhaseList=phaseList.begin(); 	
		itrPhaseList!=phaseList.end(); itrPhaseList++)   {
		strcpy(currentStr,(*itrPhaseList)->GetPhaseName());
for ( i = strlen(currentStr); i < MaxLen;i++) strcat(currentStr," ");
curNum++;
//                                      "     "
   fprintf (outst,"%4d %s  ..........%6d ........ %c\n" ,curNum,
currentStr,(*itrPhaseList)->GetNumberPhase(),(*itrPhaseList)->GetPhaseCode());
}


	fprintf (outst,"     total .............%6d .....  %d ... '+' - %d  '-' - %d\n", count,countPlusMinus,countPlus,countMinus);


		if(!phaseList.empty()) {
        	for(itrPhaseList=phaseList.begin(); 	
		itrPhaseList!=phaseList.end(); 
		itrPhaseList++)  delete (*itrPhaseList);
		phaseList.clear();
	}



return 0;
}

int Cors::GetStationInfo(char *line){
//fprintf(stderr,"%s",line);
// 
char staName[6];
char phase[9];
float distance,athimus;
	sscanf(line,"%s%s%f%f",staName,phase,&distance,&athimus);

if (distance > maxUseDistance) {indMaxDistance++;return 0;}
if (distance < minUseDistance) {indMinDistance++;return 0;}


	Station* sta = new Station(line);

strcpy(sta->GetStationCode (),staName);
strcpy(sta->GetPhaseCode (),phase);
strcpy(sta->GetPhaseCode (),phase);


sta->GetDistance () = distance; 
sta->GetAzimuthToStation () = athimus;
sta->GetPolar() = phase[0];

/*
fprintf(stderr,"st:'%s' pc:'%s' d:%6.2f az: %5.1f p: '%c'\n",
sta->GetStationCode (),
sta->GetPhaseCode (),
sta->GetDistance (),
sta->GetAzimuthToStation (),
sta->GetPolar ()
);
*/




	    itsOutStationList.push_back(sta);


return 0;
};
