#include <stdio.h>
#include "SpPrcmdw.h"
#include "SpPrSave.h"
extern int VERSIONMOMTENS;

CSpPrSave::CSpPrSave(){

}
CSpPrSave::~CSpPrSave(){
;
}
CSpPrSave::CSpPrSave(char *Name,char *OutErr,char *nameModel,int polarityScheme,
float pWaveVelValue) {
nameSourceModel = nameModel;
indPolarityScheme = polarityScheme;
pWaveVelocityValue = pWaveVelValue;
FILE *in;
 if ((in = fopen(Name, "r")) == NULL)
	   {
	    (void) fprintf(stderr, "\tFatal Error (SpPrcss):  ");
	    (void) fprintf(stderr,
			   "Fatal Error: Input file %s is not available for riding.\n",
			   Name);
	    sprintf( OutErr, "Fatal Error: Input file %s is not available for riding.\n",
			   Name);
	    return;
	  }
char dummy[256],dummy1[265];
fgets(m_Comment,256,in);
*strchr(m_Comment,'\n') = '\0';
//fprintf(stderr,"SpPrSave Open: Coments: '%s'\n",m_Comment);


fscanf(in,"%s%s",m_WorkDir,dummy);
//fprintf(stderr,"SpPrSave Open: WorkDir %s\n",m_WorkDir);

fscanf(in,"%s%s",m_DbeName,dummy);
//fprintf(stderr,"SpPrSave Open: DbName %s\n",m_DbeName);
fscanf(in,"%s%s",m_DbeRootName,dummy);
//fprintf(stderr,"SpPrSave Open: DbRootName %s\n",m_DbeRootName);
fscanf(in,"%s%s",m_DbeOriginName,dummy);
//fprintf(stderr,"SpPrSave Open: DbOriginName %s\n",m_DbeOriginName);
int i;

fscanf(in,"%d%s\n",&N_RecordList,dummy);
//fprintf(stderr,"SpPrSave Open: N_RecordList %d\n",N_RecordList);
RecordList = new char *[N_RecordList];
for (i = 0 ; i < N_RecordList; i++) {

RecordList[i] = new char[50];

fgets(RecordList[i],256,in);
*strchr(RecordList[i],'\n') = '\0';
}

fscanf(in,"%d%s\n",&N_RecordInList,dummy);
//fprintf(stderr,"SpPrSave Open: N_RecordInList %d\n",N_RecordInList);
RecordInList = new char *[N_RecordInList];
for (i = 0 ; i < N_RecordInList; i++) {

RecordInList[i] = new char[50];
fgets(RecordInList[i],256,in);
*strchr(RecordInList[i],'\n') = '\0';
}


fscanf(in,"%d%s",&N_StaList,dummy);
//fprintf(stderr,"SpPrSave Open: N_StaList %d\n",N_StaList);
StaList = new char *[N_StaList];
for (i = 0 ; i < N_StaList; i++) {
StaList[i] = new char[8];
fscanf(in,"%s",StaList[i]);

}


fscanf(in,"%d%s",&N_ModList,dummy);
//fprintf(stderr,"SpPrSave Open: N_ModList %d\n",N_ModList);

ModList = new char *[N_ModList];

for (i = 0 ; i < N_ModList; i++) {
ModList[i] = new char[8];
fscanf(in,"%s",ModList[i]);
}

 
fscanf(in,"%d%s\n",&N_ModStaList,dummy);
//fprintf(stderr,"SpPrSave Open: N_ModStaList %d %s\n",N_ModStaList,dummy);
ModStaList = new char *[N_ModStaList];
for (i = 0 ; i < N_ModStaList; i++) {
ModStaList[i] = new char[24];
fgets(ModStaList[i],256,in);
*strchr(ModStaList[i],'\n') = '\0';

}

//fscanf(in,"%s\n",dummy);
//strcpy(nameSourceModel,strchr(dummy,':')+1);
fgets(dummy1,256,in);

if (strchr(dummy1,':') != 0) {
strcpy(nameSourceModel,strchr(dummy1,':')+1);
*strrchr(nameSourceModel,'\n') = '\0';
fscanf(in,"%f%s\n",&PhVelTmin,dummy);
}
else {
sscanf(dummy1,"%f%s",&PhVelTmin,dummy);
}

fscanf(in,"%d%s\n",&PhVelCheck,dummy);   
//fprintf(stderr,"SpPrSave Open: PhVelCheck %d %s\n",PhVelCheck,dummy);
fscanf(in,"%f%s\n",&ComTmin,dummy);
//fprintf(stderr,"SpPrSave Open: ComTmin %6.2f %s\n",ComTmin,dummy);
fscanf(in,"%f%s\n",&CorrComTmin,dummy);
//fprintf(stderr,"SpPrSave Open: CorrComTmin %13.6f %s\n",CorrComTmin,dummy);
fscanf(in,"%f%s\n",&ComTmax,dummy);
//fprintf(stderr,"SpPrSave Open: ComTmax %6.2f %s\n",ComTmax,dummy);
fscanf(in,"%f%s\n",&CorrComTmax,dummy);
//fprintf(stderr,"SpPrSave Open: CorrComTmax %13.6f %s\n",CorrComTmax,dummy);
fscanf(in,"%d%s\n",&NPoints,dummy);
//fprintf(stderr,"SpPrSave Open: NPoints %d %s\n",NPoints,dummy);
fscanf(in,"%d%s\n",&TotalNum,dummy);
//fprintf(stderr,"SpPrSave Open: TotalNum %d %s\n",TotalNum,dummy);
fscanf(in,"%ld%s\n",&N2N,dummy);
//fprintf(stderr,"SpPrSave Open: N2N %ld %s\n",N2N,dummy);

fscanf(in,"%f%s\n",&StartDepth,dummy);
//fprintf(stderr,"SpPrSave Open: %13.6f - %s\n",StartDepth,dummy);
fscanf(in,"%f%s\n",&StepDepth,dummy);
//fprintf(stderr,"SpPrSave Open: %13.6f - %s\n",StepDepth,dummy);
fscanf(in,"%d%s\n",&N_StepDepth,dummy);
//fprintf(stderr,"SpPrSave Open: %d - %s\n",N_StepDepth,dummy);

      

fscanf(in,"%f%s\n",&dip0,dummy);
//fprintf(stderr,"SpPrSave Open: %13.6f - %s\n",dip0,dummy);
fscanf(in,"%f%s\n",&ddip,dummy);
//fprintf(stderr,"SpPrSave Open: %13.6f - %s\n",ddip,dummy);
fscanf(in,"%d%s\n",&ndip,dummy);
//fprintf(stderr,"SpPrSave Open: %d - %s\n",ndip,dummy);


fscanf(in,"%f%s\n",&strik0,dummy);
//fprintf(stderr,"SpPrSave Open: %13.6f - %s\n",strik0,dummy);
fscanf(in,"%f%s\n",&dstrik,dummy);
//fprintf(stderr,"SpPrSave Open: %13.6f - %s\n",dstrik,dummy);
fscanf(in,"%d%s\n",&nstrik,dummy);
//fprintf(stderr,"SpPrSave Open: %d - %s\n",nstrik,dummy);

fscanf(in,"%f%s\n",&slip,dummy);
//fprintf(stderr,"SpPrSave Open: %13.6f - %s\n",slip,dummy);
fscanf(in,"%f%s\n",&dslip,dummy);
//fprintf(stderr,"SpPrSave Open: %13.6f - %s\n",dslip,dummy);
fscanf(in,"%d%s\n",&nslip,dummy);
//fprintf(stderr,"SpPrSave Open: %d - %s\n",nslip,dummy);


fscanf(in,"%d%s\n",&N_RecPeriodList,dummy);
//fprintf(stderr,"SpPrSave Open: N_RecPeriodList %d %s\n",N_RecPeriodList,dummy);

RecPeriodList = new char *[N_RecPeriodList];
for (i = 0 ; i < N_RecPeriodList; i++) {
RecPeriodList[i] = new char[48];
fgets(RecPeriodList[i],256,in);
*strchr(RecPeriodList[i],'\n') = '\0';
}
fscanf(in,"%d%s\n",&N_RecDescrList,dummy);
//fprintf(stderr,"SpPrSave Open: N_RecDescrList %d\n",N_RecDescrList);
RecDescrList = new char *[N_RecDescrList];
for (i = 0 ; i < N_RecDescrList; i++) {
RecDescrList[i] = new char[48];
fgets(RecDescrList[i],256,in);
*strchr(RecDescrList[i],'\n') = '\0';
}





fscanf(in,"%d%s",&N_CombN2NList,dummy);
//fprintf(stderr,"SpPrSave Open: N_CombN2NList %d\n",N_CombN2NList);
CombN2NList = new char *[N_CombN2NList];

for (i = 0 ; i < N_CombN2NList; i++) {
CombN2NList[i] = new char[9];
fscanf(in,"%s",CombN2NList[i]);
}

fscanf(in,"%f%s",&m_dt,dummy);
fscanf(in,"%f%s",&m_dw,dummy);
fscanf(in,"%d%s",&m_nitems,dummy);

if (m_nitems > 0 ) {
	m_w_min  = new float  [m_nitems];  
	m_w_max  = new float  [m_nitems];   
	m_t_min  = new float  [m_nitems];  
	m_t_max  = new float  [m_nitems];	 
	m_dw0    = new float  [m_nitems]; 
	m_ipoint = new int    [m_nitems]; 

for (i = 0 ; i < m_nitems; i++)
fscanf(in,"%f%f%f%f%f%d\n",
&m_w_min[i],&m_w_max[i],&m_t_min[i],&m_t_max[i],&m_dw0[i],&m_ipoint[i]);
 
}
int Err;
//ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
fgets(dummy1,256,in);

if (strchr(dummy1,':') != 0) {
sscanf(strchr(dummy1,':')+1,"%d",&indPolarityScheme);
fgets(dummy1,256,in);
sscanf(strchr(dummy1,':')+1,"%f",&pWaveVelocityValue);
fscanf(in,"%d%s",&EnablePolari,dummy);
}
else {
sscanf(dummy1,"%d%s",&EnablePolari,dummy);
}
//ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ

//fscanf(in,"%d%s",&EnablePolari,dummy);
fscanf(in,"%d%s",&EnableMomTens,dummy);

Err =  fscanf(in,"%f%s",&angl,dummy);
if (Err == EOF || Err == 0) {
	if ( VERSIONMOMTENS == 0 ) {
 	        angl   = 0.;
  	        dangl  = 0.;
   	        nangl  = 1;
		PT_axes   = 0;
		PT_az     = -1;
		PT_dev    = 20;
		PT_min    = 1;
		variantDefinitionPolari = 0;
		minimumValuePolari = 0.1;

	} else {
 	        angl   = 0.;
  	        dangl  = 10.;
   	        nangl  = 10;
		PT_axes   = 0;
		PT_az     = -1;
		PT_dev    = 20;
		PT_min    = 1;
		variantDefinitionPolari = 0;
		minimumValuePolari = 0.1;

	}

}  else {
	fscanf(in,"%f%s",&dangl,dummy);
	fscanf(in,"%d%s",&nangl,dummy);
	Err =  fscanf(in,"%d%s",&PT_axes,dummy);
	if (Err == 0 || Err == EOF) {
		PT_axes   = 0;
		PT_az     = -1;
		PT_dev    = 20;
		PT_min    = 1;
		variantDefinitionPolari = 0;
		minimumValuePolari      = 0.1;

	} else {
	fscanf(in,"%f%s",&PT_az,dummy);
	fscanf(in,"%f%s",&PT_dev,dummy);
	fscanf(in,"%f%s",&PT_min,dummy);
		Err =  fscanf(in,"%d%s",&variantDefinitionPolari,dummy);
		if (Err == 0 || Err == EOF) {
		variantDefinitionPolari = 0;
		minimumValuePolari      = 0.1;
		} else {
			fscanf(in,"%f%s",&minimumValuePolari,dummy);
			}
       }
     		if (PT_axes == 0) {
		PT_az     = -1;
		PT_dev    = 20;
		PT_min    = 1;
		}

}

fclose ( in ) ;
strcpy(OutErr,"");
}

int CSpPrSave::SaveAs(char *Name,char *OutErr) {
 FILE *out;
  if ((out = fopen(Name, "w")) == NULL)
	   {
	    (void) fprintf(stderr, "\tFatal Error (SpPrSave):  ");
	    (void) fprintf(stderr,
			   "Fatal Error: OutPut file %s is not available for writing.\n",
			   Name);
	    sprintf( OutErr, "Fatal Error: Input file %s is not available for riding.\n",
			   Name);
	    return 1;
	  }
fprintf(out,"%s\n",m_Comment);

fprintf(out,"%s  Working_directory\n",m_WorkDir);
fprintf(out,"%s  Db_Datascope_Wfdisc_Name\n",m_DbeName);
fprintf(out,"%s  Db_Datascope_Root_Name_for_Response\n",m_DbeRootName);
fprintf(out,"%s  Db_Datascope_Origin_Name_for_Event\n",m_DbeOriginName);
int i;
fprintf(out,"%d Records_in_Record_List(Wfdisc):\n",N_RecordList);
for (i = 0 ; i < N_RecordList; i++) {
fprintf(out,"%s\n",RecordList[i]);
}

fprintf(out,"%d Records_in_RecordInList(Project):\n",N_RecordInList);
for (i = 0 ; i < N_RecordInList; i++) {
fprintf(out,"%s\n",RecordInList[i]);
}

fprintf(out,"%d Records_in_Station_List:\n",N_StaList);
for (i = 0 ; i < N_StaList; i++) {
fprintf(out,"%s\n",StaList[i]);
}
fprintf(out,"%d Records_in_Model_List:\n",N_ModList);
for (i = 0 ; i < N_ModList; i++) {
fprintf(out,"%s\n",ModList[i]);
}

fprintf(out,"%d Records_in_Model_Equivalence_Station_List:\n",N_ModStaList);
for (i = 0 ; i < N_ModStaList; i++) {
fprintf(out,"%s\n",ModStaList[i]);
}
fprintf(out,"Source_Models:%s\n",nameSourceModel);


fprintf(out,"%f Phase_Velocity_Minimum_Period\n",PhVelTmin);
fprintf(out,"%d Enable_Phase_Velocity_Model_correction\n",PhVelCheck);   
fprintf(out,"%f Common_Minimum_Period\n",ComTmin);
fprintf(out,"%f Correction_Common_Minimum_Period\n",CorrComTmin);
fprintf(out,"%f Common_Maximum_Period\n",ComTmax);
fprintf(out,"%f Correction_Common_Maximum_Period\n",CorrComTmax);
fprintf(out,"%d  Number_Points_for_every_Record\n",NPoints);
fprintf(out,"%d  Total_Number_Points_for_all_of_Records\n",TotalNum);
fprintf(out,"%ld N2N_FFT\n",N2N);
fprintf(out,"%f  Initial_Depth\n",StartDepth);
fprintf(out,"%f  Depth_Step\n",StepDepth);
fprintf(out,"%d  Amount_of_Depth_Step\n",N_StepDepth);


fprintf(out,"%f  Initial_Dip\n",dip0);
fprintf(out,"%f  Dip_Step\n",ddip);
fprintf(out,"%d  Amount_of_Dip_Step\n",ndip);

fprintf(out,"%f  Initial_Strik\n",strik0);
fprintf(out,"%f  Strik_Step\n",dstrik);
fprintf(out,"%d  Amount_of_Strik_Step\n",nstrik);

fprintf(out,"%f  Initial_Slip\n",slip);
fprintf(out,"%f  Slip_Step\n",dslip);
fprintf(out,"%d  Amount_of_Slip_Step\n",nslip);


fprintf(out,"%d Records_in_Min-Max_Period_List:\n",N_RecPeriodList);
for (i = 0 ; i < N_RecPeriodList; i++) {
fprintf(out,"%s\n",RecPeriodList[i]);
}
fprintf(out,"%d Records_in_Min-Max_Discretization_List:\n",N_RecDescrList);
for (i = 0 ; i < N_RecDescrList; i++) {
fprintf(out,"%s\n",RecDescrList[i]);
}
fprintf(out,"%d Records_in_N2N_FFT_List:\n",N_CombN2NList);
for (i = 0 ; i < N_CombN2NList; i++) {
fprintf(out,"%s\n",CombN2NList[i]);
}

fprintf(out,"%f Delta_t_in_records\n",m_dt);
fprintf(out,"%f Delta_w_for_spectra\n",m_dw);
fprintf(out,"%d Number_Records_for_Spectra_Preparation\n",m_nitems);


for (i = 0 ; i < m_nitems; i++) 
fprintf(out,"%f %f %f %f %f %d\n",
m_w_min[i],m_w_max[i],m_t_min[i],m_t_max[i],m_dw0[i],m_ipoint[i]);

 fprintf(out,"Polarity_Data_Sources:%d\n",indPolarityScheme);
 fprintf(out,"P_Wave_Velocity_Value:%f\n",pWaveVelocityValue);


 fprintf(out,"%d Enable_Polary\n",EnablePolari);
 fprintf(out,"%d Enable_MomTens\n",EnableMomTens);


 if ( VERSIONMOMTENS == 1 ) {
 fprintf(out,"%f Initial_Angle\n",angl);
 fprintf(out,"%f Angle_Step\n",dangl);
 fprintf(out,"%d Amount_of_Angle_Step\n",nangl);

 fprintf(out,"%d PT_axes\n",PT_axes);
 fprintf(out,"%f PT_azimuth\n",PT_az);
 fprintf(out,"%f PT_deviation\n",PT_dev);
 fprintf(out,"%f PT_minimum_Tension:Compression\n",PT_min);

 fprintf(out,"%d Definition_Polary_Variant\n",variantDefinitionPolari);
 fprintf(out,"%f Value_Polary_Minimum\n",minimumValuePolari);


       }

fclose ( out ) ;
return 0;
}

