czzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz
        subroutine MOMTENS(ierr,irec,iwave,perio,err_txt,ihor,haz,
     *	devi,hrat,ipola,rpola)
czzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz
c-----------------------------------------------------------------------
c       The program performs a direct exploration in parametric space
c	(0<dip<90; 0<strike<180; 0<slip<180; 0<M0; 0=<H)
c	for optimal values of parameters characterising a seismic source.
c	The optimal values provide the best fitting between observed
c	and synthetic surface wave spectra and first arrivale polarities.
c       In thise version the number of stations used in the analysis
c	krec<= 45, nw<=18, ( Nrecorders*Nmodes(L+R)*Nw <= 900 ), 
c	nz<=100, n_polari<=500, ndip<=6, nslip<=12, nstrike<=12.
c-----------------------------------------------------------------------
        common/d/  a(100),b(100),rho(100),d(100)
        common/o/  c(128,3),t(128),ratio(128,3)
        common/c/nmax,mmax,kmax,idrop,iedit,ndiv,mode,fact
        common/new/ t1,dt,c1,dc,lstop,iq,imax(10)
        common/rar/ depth(100),amprfi(100),ampz(100),strz(100),
     *  strrfi(100),mmm
        common/rar1/ dcda,dcdb,dcdr,dwx,g1(100),g2(100)
        common/rco/ ccc,cvar,ugr,wvno,rat,arle
        common/rco1/ sumi0,sumi1,sumi2,sumi3,flagr
        common/deriv/ nderiv,ndpth,dpth(1),dspz(1),dsprfi(1),
     *  drvz(4,1),drvrfi(4,1)
        real*4 y1(1800),y2(1800),y1ph(900,4),gl(6),raby(4)
        real*4 mode2(2,45)
        real*4 rab1(3),m0(2),un1(3),un2(3)
        real*8 dcda(100),dcdb(100),dcdr(100),dwx(100)
        real*8 ad(100),bd(100),rhod(100),dd(100)
        character*7 fname(2,45,3),chr
        character*1 fn1(2),fn4(3)
        character*2 fn2(45)
        character*3 fn3
        character*80 err_txt
        complex gr1(3,3,3),gr1_ex(3,3,3),rc1,rc2,rc3
        dimension gl1(6),gl0(6),amatr(1800,6),y(900),yph(900)
	dimension vect_ex(1800)
        dimension a1(100,46),b1(100,46),rho1(100,46),d1(100,46),
     *  mmax1(46),ndiv1(46),mode1(2,45),mode11(2,45,18),c11(46),
     *  dc1(46),fact1(46),dist(45),dist0(45),fi(45),fi0(45),ncomp(2,45),
     *  wmxrec(2,45,3),wmnrec(2,45,3),nstr(45),crec(45),nfile(2,45,3),
     *  mode0(2),mode01(2),wmxsor(2,3),wmnsor(2,3),istart(45)
c!!!     *  mode0(2),mode01(2),wmxsor(2,3),wmnsor(2,3),niw(279)
        real*4 cs(3),ugrs(3),sumi0s(3),vzs(3),vrfs(3),dvzs(3),
     *  dvrfs(3),cr(3),ugrr(3),sumi0r(3),vrr(3)
	real*4 vzs_ex(3),vrfs_ex(3),dvzs_ex(3),dvrfs_ex(3)
c!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        dimension numeq(2,18,3,45)
c!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
c\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
	real*4 com_spe(2,2,3,45,18),caver0(2,3,45,18)
c\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
c--------------------------------------------------------------------
c       12,12,6 - dimensions in terms of of slip, strike and dip
c       4 - four solutions, equivalent with respect to amplitudes
c--------------------------------------------------------------------
        real*4 epsamp(12,12,6,2),epsph(12,12,6,4),au1z(12,12,6),
     *  au1x(12,12,6),au1y(12,12,6),au2z(12,12,6),au2x(12,12,6),
     *  au2y(12,12,6),am0(12,12,6,2),epsp(12,12,6,4)
	real*4 am0_p(12,12,6,4),am0_ph(12,12,6,4),r_amp(2),r_pha(4),
     *	r_pol(4)
	real*4 epsamang(100),epsamdpt(100),epsphang(100),
     *	epsphdpt(100),epspang(100),epspdpt(100)
	real*4 rayl(500,3),fi_sgn(500),psg(500),si(500),pun1(3),pun2(3)
	integer ihor,ihtp,ipola,isor_start
	real*4 haz,devi,hrat,htens(2,2),hlamb(2),hvec(2,2),hpaz,htaz,
     *	rpola
75      format(1x,///5x,i2,7x,i3,2(7x,f6.0),2(12x,i2))
76      format(1x,/////i3)
11      format(1x//2(6x,i3,2x))
44      format(1x,/(4f10.4))
55      format(10x,3f10.4)
12      format(5x,f3.0)
111     format(2(5x,f6.0,2x))
	ierr=0
        pi2=6.283184
        fn1(1)='l'
        fn1(2)='r'
        fn3='mod'
        fn4(1)='1'
        fn4(2)='2'
        fn4(3)='3'
        fn2(1)='01'
        fn2(2)='02'
        fn2(3)='03'
        fn2(4)='04'
        fn2(5)='05'
        fn2(6)='06'
        fn2(7)='07'
        fn2(8)='08'
        fn2(9)='09'
        fn2(10)='10'
        fn2(11)='11'
        fn2(12)='12'
        fn2(13)='13'
        fn2(14)='14'
        fn2(15)='15'
        fn2(16)='16'
        fn2(17)='17'
        fn2(18)='18'
        fn2(19)='19'
        fn2(20)='20'
        fn2(21)='21'
        fn2(22)='22'
        fn2(23)='23'
        fn2(24)='24'
        fn2(25)='25'
        fn2(26)='26'
        fn2(27)='27'
        fn2(28)='28'
        fn2(29)='29'
        fn2(30)='30'
        fn2(31)='31'
        fn2(32)='32'
        fn2(33)='33'
        fn2(34)='34'
        fn2(35)='35'
        fn2(36)='36'
        fn2(37)='37'
        fn2(38)='38'
        fn2(39)='39'
        fn2(40)='40'
        fn2(41)='41'
        fn2(42)='42'
        fn2(43)='43'
        fn2(44)='44'
        fn2(45)='45'
        l=9
                                do 50 i=1,2
                                do 50 j=1,45
                                do 50 k=1,3
        chr(1:1)=fn1(i)
        chr(2:3)=fn2(j)
        chr(4:6)=fn3
        chr(7:7)=fn4(k)
        fname(i,j,k)=chr
        l=l+1
        nfile(i,j,k)=l
        wmxrec(i,j,k)=0.
        wmnrec(i,j,k)=0.
c-----------------------------------------------------------------------
c       fname(i,j,k), nfile(i,j,k) - file name and file number for
c       Love (i=1) or Rayleigh (i=2) mode number k, recorder number j.
c-----------------------------------------------------------------------
50                                      continue
c!!!                                do 51 i=1,279
c!!!        niw(i)=0
c!!!51                                      continue

        open(1,file='momres.inp')
        open(2,file='list.err')
c----------------------------------------------------------------------
c       Reading of input data for surface waves parameters calculations.
c----------------------------------------------------------------------
        read(1,75)kstr,kmax,wmax,dw,mode01(1),mode01(2)

        mode0(1)=mode01(1)
        mode0(2)=mode01(2)
c----------------------------------------------------------------------
c       kstr - number of structures; kmax - max number of frequencies;
c       wmax - max frequency; dw - frequency step; mode0(i) - max number
c       of Love (i=1) and Rayleigh (i=2) modes.
c----------------------------------------------------------------------
        k=mode0(1)
        read(1,121)(wmxsor(1,i),wmnsor(1,i),i=1,k)

        k=mode0(2)
        read(1,121)(wmxsor(2,i),wmnsor(2,i),i=1,k)
121     format(1x,//6f6.0)
c----------------------------------------------------------------------
c       wmnsor(j,i), wmxsor(j,i) - min and max frequency with respect to
c       all recorders for i-th Love (j=1) and Rayleigh (j=2) mode.
c----------------------------------------------------------------------
	read(1,*)
	read(1,*)z00,dz,nz
c!!!        read(1,122)z00
c!!!122     format(1x,/4x,f6.0)

c----------------------------------------------------------------------
c       z00 - depth
c----------------------------------------------------------------------
                                do 14 k=1,kstr
c----------------------------------------------------------------------
c       k=1 - source-structure
c----------------------------------------------------------------------
        read(1,11)mmax1(k),ndiv1(k)
c----------------------------------------------------------------------
c       mmax1 - number of layers to be read in, including halfspace;
c       ndiv1 - number of subdivisions for one layer;
c----------------------------------------------------------------------
        l=mmax1(k)-1
        read(1,44)(d1(i,k),a1(i,k),b1(i,k),rho1(i,k),i=1,l)
c----------------------------------------------------------------------
c       d1 - thicness of layer in kilometers,
c       a1 - compressional wave velocity in km/sec,
c       b1 - transvers wave velocity in km/sec,
c       rho1 - density in gm/sm**3.
c----------------------------------------------------------------------
        l=l+1
        read(1,55)a1(l,k),b1(l,k),rho1(l,k)
        d1(l,k)=0.0
        read(1,12)fact1(k)
c----------------------------------------------------------------------
c       fact1 - number of wavelenghts below first layer wher phase
c       velocity is less than shear velocity that we may consider
c       to be effectiv halfspace.
c----------------------------------------------------------------------
                        if(fact1(k)) 100,100,101
100     fact1(k)=4.0
101                                     continue
        read(1,111)c11(k),dc1(k)
c----------------------------------------------------------------------
c       c11 - initial phase velocity guess;
c       dc1 - phase velocity increment.
c----------------------------------------------------------------------
14                                      continue
c-----------------------------------------------------------------------
c       Reading of the number of recorders, recorders coordinates,
c       number of modes and corresponding structures numbers.
c-----------------------------------------------------------------------
        read(1,76)krec
c-----------------------------------------------------------------------
c       krec - number of recorders
c-----------------------------------------------------------------------
        read(1,77)(dist0(i),fi0(i),mode1(1,i),ncomp(1,i),mode1(2,i),
     *  ncomp(2,i),nstr(i),i=1,krec)
c!!!     *  ncomp(2,i),nstr(i),si(i),psg(i),i=1,krec)
c-----------------------------------------------------------------------
c       dist0 - length of the ray (initial epicentre-receiver);
c       fi0 - azimuth of initial epicentre-receiver direction;
c       mode1(k,i) - number of Love (k=1) and Rayleigh (k=2) modes;
c       ncomp(k,i) - number of the component of displacements
c       (1-z,2-x,3-y) in Love (k=1) and Rayleigh (k=2) modes;
c       nstr - number of corresponding structure.
c-----------------------------------------------------------------------
77      format(1x,/(2f8.0,5i5))
                                do 78 i=1,krec
        dist(i)=dist0(i)
        fi(i)=fi0(i)
78                                      continue
        read(1,22)(((wmxrec(i,j,k),wmnrec(i,j,k),k=1,3),i=1,2),j=1,krec)
c-----------------------------------------------------------------------
c       wmxrec(i,j,k),wmnrec(i,j,k) - max and min w for k-th Love (i=1)
c       or Rayleigh (i=2) mode on recorder number j.
c-----------------------------------------------------------------------
                                do 779 i=1,2
		if(mode0(i).le.0)  go to 779
                                do 79 j=1,krec
        mode2(i,j)=mode1(i,j)
79                                      continue
779					continue
22      format(1x,////(12f6.0))
        read(1,*)dip0,ddip,ndip
        read(1,*)strik0,dstrik,nstrik
        read(1,*)slip0,dslip,nslip
	slip0=180.-slip0
	dslip=-dslip
	read(1,*)
	read(1,*)ang_dc_0,d_ang_dc,n_ang_dc
	ang_dc_0=ang_dc_0*pi2/360.	
	d_ang_dc=d_ang_dc*pi2/360.	
        close(1)
c7773    format(1x,/2f5.0,i5)
        iwmax=kmax
c!!!        z0=z00
c---------------------------------------------------------------
c	Reading of fi_sgn(500),si(500),psg(500)
c       fi_sgn - azimuth of station (degrees); 
c	si - take-off angle (degrees); 
c	psg - sign of 1-st arrival (1. or -1.)
c---------------------------------------------------------------
        npsg=0
	open(1,file='polari',status='old',err=666)
		do i=1,500
	read(1,*,end=66) fi_sgn(i),si(i),psg(i)
	fi_sgn(i)=pi2*fi_sgn(i)/360.
	si(i)=pi2*si(i)/360.
	npsg=npsg+1
        rayl(i,1)=cos(si(i))
        rayl(i,2)=sin(si(i))*cos(fi_sgn(i))
        rayl(i,3)=sin(si(i))*sin(fi_sgn(i))
		end do
66			continue
	close(1)
666					continue

c---------------------------------------------------------------
c!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
                                do 791 i=1,2
                                do 791 j=1,18
                                do 791 k=1,3
                                do 791 l=1,45
        numeq(i,j,k,l)=999
791                                     continue
c!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		do 8000 i=1,2
		do 8000 j=1,3
		do 8000 k=1,45
	chr=fname(i,k,j)
	open(11,file=chr,status='old',err=8001)
	read(11,*)
		do 8003 l=1,18
        w=wmax-dw*(l-1)
        r3=wmnrec(i,k,j)
        r4=wmxrec(i,k,j)
                        if(w.lt.r3) go to 8002
			if(w.gt.r4) go to 8003
	read(11,*)com_spe(1,i,j,k,l),com_spe(2,i,j,k,l),caver0(i,j,k,l)
8003		continue
8002		continue
	close(11)
8001		continue
8000		continue
                                do 5551 kdip=1,6
                                do 5551 kstrik=1,12
                                do 5551 kslip=1,12
        epsamp(kslip,kstrik,kdip,1)=99.
        epsamp(kslip,kstrik,kdip,2)=99.
                                do 5550 k=1,4
        epsph(kslip,kstrik,kdip,k)=99.
        epsp(kslip,kstrik,kdip,k)=99.
5550                                    continue
5551                                    continue
	eps0=99.
	ang_min=99.
		do k=1,100
	epsamang(k)=99.
	epsamdpt(k)=99.
	epsphang(k)=99.
	epsphdpt(k)=99.
	epspang(k)=99.
	epspdpt(k)=99.
		end do
	nvar=0
	kvar=1
	nvar_max=ndip*nstrik*nslip*n_ang_dc*nz
c---------------------------------------------------------------------
c		        CD depths cycle
c---------------------------------------------------------------------


			do idepth=1,nz
			z0=z00+dz*(idepth-1)
        nequ=0
        nph=0
        dpth(1)=z0
        ndpth=1
c-----------------------------------------------------------------------
c       L,R-cycle
c-----------------------------------------------------------------------
                                do 9999 ifunc=1,2 
                                                go to (10,20),ifunc
10                      if(mode0(1).le.0)       go to 9999
                                                go to 30
20                      if(mode0(2).le.0)       go to 9999
30                                      continue
        cs(1)=c11(1)
                                do 7770 j=1,krec
        mode1(ifunc,j)=mode2(ifunc,j)
        jj=nstr(j)
        crec(j)=c11(jj)
	istart(j)=0
c!!!        k1=mode1(ifunc,j)
c!!!                        if(k1.eq.0)             go to 7770
c!!!                                do 7700 k=1,k1
c!!!        r3=wmnrec(ifunc,j,k)
c!!!        r4=wmxrec(ifunc,j,k)
c!!!                        if(r3.le.1.0e-6.and.r4.le.1.0e-6) go to 7770
c!!!        mfile=nfile(ifunc,j,k)
c!!!        chr=fname(ifunc,j,k)
c!!!        open(mfile,file=chr)
c!!!7700                                    continue 
7770                                    continue 
	isor_start=0
        kmax=1
                                do 8888 iw=1,iwmax
        w=wmax-dw*(iw-1)
        t(1)=pi2/w
c-----------------------------------------------------------------------
c       SURFACE for the source-structure (all modes)
c-----------------------------------------------------------------------
        number=0
        numbel=0
        iedit=2
        mmax=mmax1(1)
        nmax=mmax
        ndiv=ndiv1(1)
        mode=mode0(ifunc)
                                do 8880 i=1,mmax
        dd(i)=d1(i,1)
        ad(i)=a1(i,1)
        bd(i)=b1(i,1)
        rhod(i)=rho1(i,1)
8880                                    continue
        call flat(dd,rhod,ad,bd,mmax,ifunc)
                                do 9880 i=1,mmax
        d(i)=dd(i)
        a(i)=ad(i)
        b(i)=bd(i)
        rho(i)=rhod(i)
9880                                    continue
        fact=fact1(1)
        dc=dc1(1)
        c1=cs(1)-0.1
                        if(iw.eq.1.or.isor_start.lt.1) c1=c11(1)
        call disper(ifunc,ierr)
		if(ierr.ne.0) then
		irec=0
		iwave=ifunc
				RETURN
		end if
                                do 8881 i=1,mode
        j=mode-i+1
        l=imax(j)
                        if(l.eq.0) mode0(ifunc)=mode0(ifunc)-1
8881                                    continue
        mode=mode0(ifunc)
                        if(mode.gt.0)           go to 4040
	ierr=1
	irec=0
	iwave=ifunc
	perio=pi2/w
	err_txt=
     *	'Phase velocity for source structure can not be calculated!@'
					RETURN
4040                    continue
        nderiv=1
                                do 8884 iq=1,mode
        r1=wmnsor(ifunc,iq)
        r2=wmxsor(ifunc,iq)
c----------------------------------------------------------------------
c       wmnsor(j,i), wmxsor(j,i) - min and max frequency with respect to
c       all recorders for i-th Love (j=1) and Rayleigh (j=2) mode.
c----------------------------------------------------------------------
                        if(w.lt.r1.or.w.gt.r2)  go to 8884
                                                goto (7781,7782),ifunc
7781                                    continue
        number=-1
        call leigen(numbel,1,iq)
        numbel=numbel+1
                                                go to 8882
7782                                    continue
        call reigen(number,1,iq)
                        if(number.eq.-1) number=0
        number=number+1
8882                                    continue
        cs(iq)=ccc
	isor_start=1
        ugrs(iq)=ugr
        sumi0s(iq)=sumi0
        vrfs(iq)=dsprfi(1)
        vzs(iq)=dspz(1)
        dvrfs(iq)=drvrfi(1,1)
        dvzs(iq)=drvz(1,1)
c-----------------------------------------------------------------------
c       will be used if ifunc=2 and nstr(1)=1
c-----------------------------------------------------------------------
        vrr(iq)=amprfi(1)
8884                                    continue
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
c-----------------------------------------------------------------------
c	Calculation of eigen functions and their derivatives at free 
c	surface - for explosion estimate
c-----------------------------------------------------------------------
			if(ifunc.eq.1) go to 2222
        dpth(1)=0.
        number=0
        iedit=2
        mmax=mmax1(1)
        nmax=mmax
        ndiv=ndiv1(1)
        mode=mode0(2)
                                do 880 i=1,mmax
        dd(i)=d1(i,1)
        ad(i)=a1(i,1)
        bd(i)=b1(i,1)
        rhod(i)=rho1(i,1)
880                                    continue
        call flat(dd,rhod,ad,bd,mmax,2)
                                do 988 i=1,mmax
        d(i)=dd(i)
        a(i)=ad(i)
        b(i)=bd(i)
        rho(i)=rhod(i)
988                                    continue
        fact=fact1(1)
        dc=dc1(1)
        c1=cs(1)-0.1
		if(iw.eq.1.or.isor_start.lt.1)c1=c11(1)
        call disper(2,ierr)
        mode=mode0(2)
        nderiv=1
                                do 884 iq=1,mode
        r1=wmnsor(ifunc,iq)
        r2=wmxsor(ifunc,iq)
c----------------------------------------------------------------------
c       wmnsor(j,i), wmxsor(j,i) - min and max frequency with respect to
c       all recorders for i-th Love (j=1) and Rayleigh (j=2) mode.
c----------------------------------------------------------------------
                        if(w.lt.r1.or.w.gt.r2)  go to 884
        call reigen(number,1,iq)
c                        if(number.eq.-1) number=0
        number=number+1
        vrfs_ex(iq)=dsprfi(1)
        vzs_ex(iq)=dspz(1)
        dvrfs_ex(iq)=drvrfi(1,1)
        dvzs_ex(iq)=drvz(1,1)
884				continue 
        dpth(1)=z0
2222			continue 
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
c-----------------------------------------------------------------------
c       recorders-cycle
c-----------------------------------------------------------------------
                                do 8887 nrec=1,krec
        mode=mode1(ifunc,nrec)
                        if(mode.le.0)           go to 8887
        dist1=dist(nrec)
        fi1=fi(nrec)
        i=nrec-1
        j=1
                        if(i.ne.0) j=nstr(i)
                        if(nstr(nrec).ne.j)     go to 8885
        l=mode0(ifunc)
                        if(i.ne.0) l=mode1(ifunc,i)
                        if(mode.gt.l)           go to 8885
                                do 8874 iq=1,mode
        r1=wmnsor(ifunc,iq)
        r2=wmxsor(ifunc,iq)
                        if(i.ne.0) r1=wmnrec(ifunc,i,iq)
                        if(i.ne.0) r2=wmxrec(ifunc,i,iq)
        r3=wmnrec(ifunc,nrec,iq)
        r4=wmxrec(ifunc,nrec,iq)
c-----------------------------------------------------------------------
c       wmxrec(i,j,k),wmnrec(i,j,k) - max and min w for k-th Love (i=1)
c       or Rayleigh (i=2) mode on recorder number j.
c-----------------------------------------------------------------------
                        if(w.lt.r3.or.w.gt.r4)  go to 8874
                        if(w.lt.r1.or.w.gt.r2)  go to 8885
8874                                    continue
                        if(i.ne.0)              go to 8886
                                do 8875 iq=1,mode
        cr(iq)=cs(iq)
        ugrr(iq)=ugrs(iq)
        sumi0r(iq)=sumi0s(iq)
8875                                    continue
                                                go to 8886
8885                                    continue
c-----------------------------------------------------------------------
c       SURFACE for the recorders-structures (all of modes)
c-----------------------------------------------------------------------
        number=0
        numbel=0
        iedit=1
        jstr=nstr(nrec)
        mmax=mmax1(jstr)
        nmax=mmax
        ndiv=ndiv1(jstr)
        mode=mode1(ifunc,nrec)
                                do 9990 i=1,mmax
        dd(i)=d1(i,jstr)
        ad(i)=a1(i,jstr)
        bd(i)=b1(i,jstr)
        rhod(i)=rho1(i,jstr)
9990                                    continue
        call flat(dd,rhod,ad,bd,mmax,ifunc)
                                do 8990 i=1,mmax
        d(i)=dd(i)
        a(i)=ad(i)
        b(i)=bd(i)
        rho(i)=rhod(i)
8990                                    continue
        fact=fact1(jstr)
        dc=dc1(jstr)
        c1=crec(nrec)-0.1
                        if(iw.eq.1.or.istart(nrec).lt.1) c1=c11(jstr)
        call disper(ifunc,ierr)
		if(ierr.ne.0) then
		irec=nrec
		iwave=ifunc
				RETURN
		end if
        i1=0
                                do 9991 i=1,mode
        j=mode-i+1
        l=imax(j)
                        if(l.gt.0)              go to 9991
        mode1(ifunc,nrec)=mode1(ifunc,nrec)-1
        i1=1
9991                                    continue
        mode=mode1(ifunc,nrec)
                        if(mode.gt.0)           go to 40
	ierr=1
	irec=nrec
	iwave=ifunc
	perio=pi2/w
	err_txt=
     *	'Phase velocity can not be calculated!@'
					RETURN
40                                      continue
                                do 9993 iq=1,mode
        r3=wmnrec(ifunc,nrec,iq)
        r4=wmxrec(ifunc,nrec,iq)
                        if(w.lt.r3.or.w.gt.r4)  go to 9993
                                                goto (8871,8872),ifunc
8871                                    continue
        number=-1
        call leigen(numbel,1,iq)
        numbel=numbel+1
                                                go to 9992
8872                                    continue
        call reigen(number,1,iq)
                        if(number.eq.-1) number=0
        number=number+1
9992                                    continue
        cr(iq)=ccc
        ugrr(iq)=ugr
        sumi0r(iq)=sumi0
        vrr(iq)=amprfi(1)
c-----------------------------------------------------------------------
c       will be used as c1 at next w
c-----------------------------------------------------------------------
                        if(iq.eq.1)  then
	crec(nrec)=cr(1)
	istart(nrec)=istart(nrec)+1
	end if
9993                                    continue
8886                                    continue
                                do 9994 iq=1,mode
        r3=wmnrec(ifunc,nrec,iq)
        r4=wmxrec(ifunc,nrec,iq)
                        if(w.lt.r3.or.w.gt.r4)  go to 9994
        cs1=cs(iq)
        ugrs1=ugrs(iq)
        sum0s=sumi0s(iq)
        cr1=cr(iq)
        ugrr1=ugrr(iq)
        sum0r=sumi0r(iq)
        vrr1=vrr(iq)
        lr=ifunc-1
        vzs1=vzs(iq)
        vrfs1=vrfs(iq)
        dvzs1=dvzs(iq)
        dvrfs1=dvrfs(iq)
c!!!        mfile=nfile(ifunc,nrec,iq)
c!!!        iww=niw(mfile)
c!!!        if(iww.eq.0) read(mfile,*)yerr,sp,rp
c!!!        niw(mfile)=1
        l=nequ/2+1
        nph=nph+1
c!!!        read(mfile,*)reu,aimu,caver
	reu=com_spe(1,ifunc,iq,nrec,iw)
	aimu=com_spe(2,ifunc,iq,nrec,iw)
	caver=caver0(ifunc,iq,nrec,iw)
        r1=reu*reu+aimu*aimu
        y(l)=sqrt(r1)
		if(y(l).lt.1.e-30) then
		yph(l)=0.
		else
        r2=aimu/y(l)
        r3=reu/y(l)
        call arctan(r2,r3,r1)
        yph(l)=r1
		end if
                        if(caver.gt.1.0e-6)     go to 1111
        caver=cs1
        yph(l)=pi2+1.
        nph=nph-1
1111                                    continue
        call green1(cs1,ugrs1,sum0s,vzs1,vrfs1,dvzs1,dvrfs1,cr1,
     *  ugrr1,sum0r,vrr1,lr,w,dist1,fi1,caver,gr1,ierr)
		if(ierr.ne.0) then
	irec=nrec
		err_txt=
     *	'Cut off from the list - too close to the epicenter antipode@'
			RETURN
		end if
c-----------------------------------------------------------------------
c	Green1 for explosion 
c-----------------------------------------------------------------------
		if(ifunc.eq.2) then
	vzs1=vzs_ex(iq)
	vrfs1=vrfs_ex(iq)
        dvzs1=dvzs_ex(iq)
       	dvrfs1=dvrfs_ex(iq)
        call green1(cs1,ugrs1,sum0s,vzs1,vrfs1,dvzs1,dvrfs1,cr1,
     *  ugrr1,sum0r,vrr1,lr,w,dist1,fi1,caver,gr1_ex,ierr)
		end if
c-----------------------------------------------------------------------
c       The matrix for DC is amatr(1800,6), 
c	for explosion it is a vector vect_ex(1800), 
c	the vector of measured modulie is "y"
c       ( Nrecorders*Nmodes(L+R)*Nw <= 900 ),
c       DC moment tensor gl(i) :
c		{m(1,1);m(2,1);m(3,1);m(2,2);m(3,2);m(3,3)}.
c	Explosion moment tensor: Me*{1;0;0;1;0;1}
c-----------------------------------------------------------------------
        j=ncomp(ifunc,nrec)
        k2=1
                                do 3333 l=1,3
                                do 3333 k=l,3
        rl=l
        rk=k
        kk=rl/rk+1.1
        r1=kk
        rc1=gr1(j,k,l)+gr1(j,l,k)
        rc2=(0.,1.)*w*r1
        rc3=rc1/rc2
        r1=real(rc3)
        r2=aimag(rc3)
        k1=nequ+1
        amatr(k1,k2)=r1
        k1=k1+1
        amatr(k1,k2)=r2
        k2=k2+1
3333                                    continue
        k1=nequ+1
	vect_ex(k1)=0.
	vect_ex(k1+1)=0.
			if(ifunc.eq.2) then
	rc1=gr1_ex(j,1,1)+gr1_ex(j,2,2)+gr1_ex(j,3,3)
        rc2=(0.,1.)*w
	rc3=sqrt(2./3.)*rc1/rc2
        vect_ex(k1)=real(rc3)
        k1=k1+1
        vect_ex(k1)=aimag(rc3)
			end if
c!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        numeq(ifunc,iw,iq,nrec)=nequ+1
c!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        nequ=nequ+2
c-----------------------------------------------------------------------
c       end of modes-cycle
c-----------------------------------------------------------------------
9994                                    continue
        mode11(ifunc,nrec,iw)=mode1(ifunc,nrec)
c-----------------------------------------------------------------------
c       end of recorders-cycle
c-----------------------------------------------------------------------
8887                                    continue
c-----------------------------------------------------------------------
c       end of w-cycle
c-----------------------------------------------------------------------
8888                                    continue
c!!!                                do 7772 j=1,krec
c!!!        k1=mode1(ifunc,j)
c!!!                        if(k1.eq.0)             go to 7772
c!!!                                do 7771 k=1,k1
c!!!        r3=wmnrec(ifunc,j,k)
c!!!        r4=wmxrec(ifunc,j,k)
c!!!                        if(r3.le.1.0e-6.and.r4.le.1.0e-6) go to 7771
c!!!        close(nfile(ifunc,j,k))
c!!!7771                                    continue
c!!!7772                                    continue
c-----------------------------------------------------------------------
c       end of L,R-cycle
c-----------------------------------------------------------------------
9999                                    continue
c!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
                                do 796 i=1,2
                                do 796 j=1,18
                                do 796 k=1,3
        keq=0
        avery=0.
                                do 792 l=1,45
                        if(numeq(i,j,k,l).eq.999) go to 792
        ll=(numeq(i,j,k,l)+1)/2
        keq=keq+1
        avery=avery+y(ll)*y(ll)
792                                     continue
                        if(keq.eq.0) go to 796
        avery=avery/keq
        avery=sqrt(avery)
                                do 795 l=1,45
                        if(numeq(i,j,k,l).eq.999) go to 795
        ll=(numeq(i,j,k,l)+1)/2
        y(ll)=y(ll)/avery
        k1=numeq(i,j,k,l)
                                do 794 ii=1,2
                                do 793 k2=1,6
        amatr(k1,k2)=amatr(k1,k2)/avery
793                                     continue
	vect_ex(k1)=vect_ex(k1)/avery
        k1=k1+1
794                                     continue
795                                     continue
796                                     continue
c!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        ngl=5
c-----------------------------------------------------------------------
c       Condition gl(1)=-gl(4)-gl(6) is accepted. 'amatr' is reducing
c       with respect to the 1-st column and gl(i) is reducing with 
c       respect to the 1-st component.
c-----------------------------------------------------------------------
                                do 4443 k=1,nequ
        amatr(k,4)=amatr(k,4)-amatr(k,1)
        amatr(k,6)=amatr(k,6)-amatr(k,1)
4443                                    continue
                                do 4444 k2=2,6
        k=k2-1
                                do 4444 k1=1,nequ
        amatr(k1,k)=amatr(k1,k2)
4444                                    continue
        eps1=0.
        j=nequ/2
                                do 6666 i=1,j
        eps1=eps1+(y(i)*y(i))
6666                                    continue
c---------------------------------------------------------------------
c	Cycle by the angle between moment tensor and pure DC
c---------------------------------------------------------------------
			do iang=1,n_ang_dc
	ang_dc=ang_dc_0+(iang-1)*d_ang_dc
	rsin=sin(ang_dc)
	rcos=cos(ang_dc)
		if(abs(rcos).lt.1.e-6.and.idepth.ne.1) then
       	nvar=nvar+nstrik*nslip*ndip
       	kvar=kvar+(nstrik*nslip*ndip/100+1)*100
		go to 5557
		end if
                                do 5556 kdip=1,ndip
			if(abs(rcos).lt.1.e-6.and.kdip.ne.1) then
        	nvar=nvar+nstrik*nslip
        	kvar=kvar+(nstrik*nslip/100+1)*100
			go to 5556
			end if
        dip=(dip0+ddip*(kdip-1))*pi2/360.
        cosdp=cos(dip)
        sindp=sin(dip)
        un1(1)=cosdp
                                do 5555 kstrik=1,nstrik
        strike=(strik0+dstrik*(kstrik-1))*pi2/360.
        cosst=cos(strike)
        sinst=sin(strike)
        un1(2)=sindp*sinst
        un1(3)=-sindp*cosst
                                do 5555 kslip=1,nslip
        slip=(slip0+dslip*(kslip-1))*pi2/360.
        cossl=cos(slip)
        sinsl=sin(slip)
        un2(1)=sinsl*sindp
        un2(2)=cossl*cosst-sinsl*sinst*cosdp
        un2(3)=cossl*sinst+sinsl*cosst*cosdp
        gl0(1)=2.*un1(1)*un2(1)
        gl0(2)=un1(1)*un2(2)+un1(2)*un2(1)
        gl0(3)=un1(1)*un2(3)+un1(3)*un2(1)
        gl0(4)=2.*un1(2)*un2(2)
        gl0(5)=un1(2)*un2(3)+un1(3)*un2(2)
        gl0(6)=2.*un1(3)*un2(3)
c--------------------------------------------------------------------
c	Test of horizontal deformations (htens) orientation 
c	(if ihor.ne.0). If appriori limitation is given and 
c	max(abs(htens(i,j)))<accur, what means that horizontal 
c	deformations are too small (the focal mechanism is close 
c	to horizontal slip of horizontal plane), then such a solution 
c	will be rejected. Now accur=0.1 which corresponds
c	to a thrust of subhorizontal plane with dip=4deg.
c	If main horizontal axes are close to appriori direction,
c	and deformation mentioned as dominant is not too small,
c	then current mechanism will be considered.
c--------------------------------------------------------------------
	if(ihor.eq.0)	then
			ii1=1
			ii2=2
	else
		accur=0.1
		htens(1,1)=gl0(6)
		htens(1,2)=gl0(5)
		htens(2,1)=gl0(5)
		htens(2,2)=gl0(4)
		call eig_2dim(accur,ihtp,htens,hlamb,hvec)
			if(ihtp.eq.0) go to 			5552
		hpaz=acos(hvec(1,2))*360./pi2
		if(hvec(1,1).lt.0.) hpaz=180.-hpaz
		if(abs(hvec(1,1)).lt.1.e-6) hpaz=0.
		htaz=hpaz+90.
		if(htaz.ge.180.)  htaz=htaz-180.
		ii1=0
		if(ihor.eq.-1) then
				hrab1=1.e9
				if(hlamb(2).gt.1.e-9)hrab1=
     *						abs(hlamb(1)/hlamb(2))
				hrab2=1.e9
				if(hlamb(1).lt.-1.e-9)hrab2=
     *						abs(hlamb(2)/hlamb(1))
			if(abs(hpaz-haz).le.devi.and.
     *				hrab1.ge.hrat.and.hlamb(1).lt.0.) then
				ii1=1
				ii2=1
				if(abs(htaz-haz).le.devi.and.
     *				hrab2.ge.hrat.and.hlamb(2).gt.0.) ii2=2
			else
				if(abs(htaz-haz).le.devi.and.
     *				hrab2.ge.hrat.and.hlamb(2).gt.0.) then
				ii1=2
				ii2=2
				end if
			end if
					if(ii1.eq.0) go to 	5552
		else
				hrab1=1.e9
				if(hlamb(1).lt.-1.e-9)hrab1=
     *						abs(hlamb(2)/hlamb(1))
				hrab2=1.e9
				if(hlamb(2).gt.1.e-9)hrab2=
     *						abs(hlamb(1)/hlamb(2))
			if(abs(htaz-haz).le.devi.and.
     *				hrab1.ge.hrat.and.hlamb(2).gt.0.) then
				ii1=1
				ii2=1
				if(abs(hpaz-haz).le.devi.and.
     *				hrab2.ge.hrat.and.hlamb(1).lt.0.) ii2=2
			else
				if(abs(hpaz-haz).le.devi.and.
     *				hrab2.ge.hrat.and.hlamb(1).lt.0.) then
				ii1=2
				ii2=2
				end if
			end if
					if(ii1.eq.0) go to 	5552
		end if
	end if
c-------------------------------------------------------------------
c   Calculation of normalized residual
c-------------------------------------------------------------------
                                do 21 i=1,ngl
        j=i+6-ngl
        gl(i)=gl0(j)
        gl1(i)=gl0(j)
21                                      continue
        gl1(1)=-gl1(1)
        gl1(2)=-gl1(2)
        r6=pi2/2.
c--------------------------------------------------------------------
c	Cycle ii=1,2 - change of DC T-P axes. ii=1 corresponds to 
c	k=1,2 for phayses and polarities, ii=2 - to k=3,4.
c--------------------------------------------------------------------
                    do ii=ii1,ii2
	iii=ii+1
	ri=(-1)**iii
                                do 26 i=1,nequ,2
        k1=1+i/2
        l=i+1
        y1(i)=rsin*vect_ex(i)
        y1(l)=rsin*vect_ex(l)
        y2(i)=rsin*vect_ex(i)
        y2(l)=rsin*vect_ex(l)
                                do 25 j=1,ngl
        y1(i)=rcos*amatr(i,j)*gl(j)*ri+y1(i)
        y1(l)=rcos*amatr(l,j)*gl(j)*ri+y1(l)
        y2(i)=rcos*amatr(i,j)*gl1(j)*ri+y2(i)
        y2(l)=rcos*amatr(l,j)*gl1(j)*ri+y2(l)
25                                      continue
        r1=y1(i)*y1(i)+y1(l)*y1(l)
        r1=sqrt(r1)
                        if(yph(k1).gt.pi2)        go to 27
        r2=y1(l)/r1
        r3=y1(i)/r1
        call arctan(r2,r3,r4)
	k2=2*ii-1
        y1ph(k1,k2)=r4
c!!!        y1ph(k1,1)=r4
c!!!        y1ph(k1,3)=r4+r6
c!!!                        if(r4.ge.r6)    y1ph(k1,3)=r4-r6
        r5=y2(i)*y2(i)+y2(l)*y2(l)
        r5=sqrt(r5)
        r2=y2(l)/r5
        r3=y2(i)/r5
        call arctan(r2,r3,r4)
	k2=2*ii
        y1ph(k1,k2)=r4
c!!!        y1ph(k1,2)=r4
c!!!        y1ph(k1,4)=r4+r6
c!!!                        if(r4.ge.r6)    y1ph(k1,4)=r4-r6
27                                      continue
        y1(k1)=r1
26                                      continue
        j=nequ/2
        r1=0.
        r2=0.
        r3=0.
                                do 18 i=1,j
        r1=r1+y1(i)*y(i)
        r3=r3+y1(i)*y1(i)
18                                      continue
        m0(ii)=r1/r3
	kn1=2*ii-1
	kn2=kn1+1
        raby(kn1)=0.
        raby(kn2)=0.
c!!!        raby(1)=0.
c!!!        raby(2)=0.
c!!!        raby(3)=0.
c!!!        raby(4)=0.
                                do 6665 i=1,j
        r2=r2+(y(i)-m0(ii)*y1(i))*(y(i)-m0(ii)*y1(i))
                        if(yph(i).gt.pi2)        go to 6665
c!!!                                do 6664 k=1,4
                                do 6664 k=kn1,kn2
        r3=abs(yph(i)-y1ph(i,k))
                        if(r3.gt.r6)    r3=r3-pi2
        raby(k)=raby(k)+r3*r3
6664                                    continue
6665                                    continue
        r2=r2/eps1
c!!!        epsamp(kslip,kstrik,kdip,ii)=sqrt(r2)
	r_amp(ii)=sqrt(r2)
		if(r_amp(ii).lt.epsamp(kslip,kstrik,kdip,ii)) then
	epsamp(kslip,kstrik,kdip,ii)=r_amp(ii)
        am0(kslip,kstrik,kdip,ii)=m0(ii)*1.0e20
		end if
	if(r_amp(ii).lt.epsamang(iang)) epsamang(iang)=r_amp(ii)
	if(r_amp(ii).lt.eps0) then
	ang_min=ang_dc
	eps0=r_amp(ii)
	end if
	if(r_amp(ii).lt.epsamdpt(idepth)) epsamdpt(idepth)=r_amp(ii)
                        if(nph.eq.0)    go to 6663
c!!!                                do 6662 k=1,4
                                do 6662 k=kn1,kn2
        r1=raby(k)/nph
c!!!        epsph(kslip,kstrik,kdip,k)=sqrt(r1)/r6
	r_pha(k)=sqrt(r1)/r6
	r_pha(k)=1.-(1.-r_amp(ii))*(1.-r_pha(k))
		if(r_pha(k).lt.epsph(kslip,kstrik,kdip,k)) then
	epsph(kslip,kstrik,kdip,k)=r_pha(k)
	am0_ph(kslip,kstrik,kdip,k)=m0(ii)*1.0e20
		end if
	if(r_pha(k).lt.epsphang(iang)) epsphang(iang)=r_pha(k)
	if(r_pha(k).lt.epsphdpt(idepth)) epsphdpt(idepth)=r_pha(k)
6662                                    continue
6663                                    continue
c--------------------------------------------------------------------
c	End of cycle ii=1,2 - change of DC T-P axes
c--------------------------------------------------------------------
		end do

        au1z(kslip,kstrik,kdip)=un1(1)
        au1x(kslip,kstrik,kdip)=un1(2)
        au1y(kslip,kstrik,kdip)=un1(3)
        au2z(kslip,kstrik,kdip)=un2(1)
        au2x(kslip,kstrik,kdip)=un2(2)
        au2y(kslip,kstrik,kdip)=un2(3)
                        if(npsg.eq.0)   go to 5552
	kk1=2*ii1-1
	kk2=2*ii2
                do 5553 kk=kk1,kk2
        i=(kk-1)*(kk-2)/2
        r1=(-1)**i
        i=kk+1
        r2=(-1)**i
        pun1(1)=un1(1)
        pun1(2)=un1(2)*r2
        pun1(3)=un1(3)*r2
        pun2(1)=un2(1)*r1
        pun2(2)=un2(2)*r1*r2
        pun2(3)=un2(3)*r1*r2
        r1=0.
        r2=0.
c!!!                do 5554 k=1,krec
                do 5554 k=1,npsg
        i=psg(k)+0.5*sign(1.,psg(k))
                        if(i.eq.0)      go to 5554
        rab1(1)=rayl(k,1)
        rab1(2)=rayl(k,2)
        rab1(3)=rayl(k,3)
        r3=psgnexdc(pun1,pun2,rab1,rsin,rcos,ipola,rpola)
        j=r3+0.5*sign(1.,r3)
                        if(j.eq.0)      go to 5554      
        r2=r2+1.
                        if(i.ne.j)      r1=r1+1.
5554                                    continue
c!!!        epsp(kslip,kstrik,kdip,kk)=0.
c!!!                if(r2.ne.0.) epsp(kslip,kstrik,kdip,kk)=r1/r2
	r_pol(kk)=0.
		if(r2.ne.0.) r_pol(kk)=r1/r2
c-------------------------------------------------------------
c	ii=1 if kk=1,2; ii=2 if kk=3,4
c-------------------------------------------------------------
	rkk=kk
	ii=rkk/2.5+1.
	r_pol(kk)=1.-(1.-r_amp(ii))*(1.-r_pol(kk))
		if(r_pol(kk).lt.epsp(kslip,kstrik,kdip,kk)) then
	epsp(kslip,kstrik,kdip,kk)=r_pol(kk)
	am0_p(kslip,kstrik,kdip,kk)=m0(ii)*1.0e20
		end if
	if(r_pol(kk).lt.epspang(iang)) epspang(iang)=r_pol(kk)
	if(r_pol(kk).lt.epspdpt(idepth)) epspdpt(idepth)=r_pol(kk)
5553                                    continue
c!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
5552                                    continue
        nvar=nvar+1
                        if(nvar.eq.kvar) then
         nsyst=system ('clear')
        write(*,2296) nvar,nvar_max

        kvar=kvar+100
2296    format(i7,'     variant of    ',i7)
                        end if
c!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
5555                                    continue
5556				continue
5557				continue
c---------------------------------------------------------------------
c	End of the cycle by the angle between moment tensor and pure DC
c---------------------------------------------------------------------
				end do
c---------------------------------------------------------------------
c		End of depths cycle
c---------------------------------------------------------------------
		end do
        angmin=ddip
                        if(dstrik.lt.angmin) angmin=dstrik
                        if(dslip.lt.angmin) angmin=dslip
        open(1,file='epsamang')
		do i=1,n_ang_dc
	ang_dc=(ang_dc_0+(i-1)*d_ang_dc)*360./pi2
		write(1,*)ang_dc,epsamang(i)
		end do
        close(1)
        open(1,file='epsamdpt')
		do i=1,nz
			z0=z00+dz*(i-1)
		write(1,*)z0,epsamdpt(i)
		end do
        close(1)
        open(1,file='epsphang')
		do i=1,n_ang_dc
	ang_dc=(ang_dc_0+(i-1)*d_ang_dc)*360./pi2
		write(1,*)ang_dc,epsphang(i)
		end do
        close(1)
        open(1,file='epsphdpt')
		do i=1,nz
			z0=z00+dz*(i-1)
		write(1,*)z0,epsphdpt(i)
		end do
        close(1)
        open(1,file='epspang')
		do i=1,n_ang_dc
	ang_dc=(ang_dc_0+(i-1)*d_ang_dc)*360./pi2
		write(1,*)ang_dc,epspang(i)
		end do
        close(1)
        open(1,file='epspdpt')
		do i=1,nz
			z0=z00+dz*(i-1)
		write(1,*)z0,epspdpt(i)
		end do
        close(1)
        open(1,file='map_gmt.inp')
        write(1,*)epsamp,epsph,epsp,am0,am0_p,am0_ph,au1z,au1x,au1y,
     *	au2z,au2x,au2y,angmin,nph,npsg,ang_min
        close(1)
        close(2)
                                                                RETURN
                                                                END
czzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz
	Subroutine eig_2dim(accur,ihtp,a,l,r)
czzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz
c----------------------------------------------------------------------
c       Subroutine EIG_2D calculates eigenvalues l(2) 
c	and eigenvectors r(2,2) (r(i,j)- j-th coordinate of the 
c	i-th eigenvector) of 2x2 simmetric matrix a. 
c	If abs(a(1,2))/max(abs(a(i,j)))=<0.01, then r(1,1)=1, r(1,2)=0,
c	r(2,1)=0, r(2,2)=1, l(1)=a(1,1), l(2)=a(2,2) - matrix is 
c	considering as diagonal.
c	If max(abs(a(i,j)))<accur then ihtp=0 - horizontal deformations
c	are too small (the focal mechanism is close to horizontal slip
c	of horizontal plane).
c	The eigenvalues are normalized (l(1)**2+l(2)**2=1) and ordered 
c	(l(1)=<l(2)).
c----------------------------------------------------------------------
	real*4 a(2,2),l(2),r(2,2)
	integer ihtp
		ihtp=1
		amax=0.
		do i=1,2
			do j=1,2
		if(abs(a(i,j)).gt.amax) amax=abs(a(i,j))
			end do
		end do
					if(amax.le.accur) then
					ihtp=0
					RETURN
					end if
				if((abs(a(1,2))/amax).le.0.01) then
			r(1,1)=1.
			r(1,2)=0.
			r(2,1)=0. 
			r(2,2)=1.
			l(1)=a(1,1)
			l(2)=a(2,2)
				else
		rab1=0.5*(a(1,1)+a(2,2))
		rab2=0.5*sqrt((a(1,1)-a(2,2))**2+4.*(a(1,2))**2)
		l(1)=rab1+rab2
		l(2)=rab1-rab2
			do i=1,2
			rab1=sqrt((a(1,2))**2+(l(i)-a(1,1))**2)
			r(i,1)=a(1,2)/rab1
			r(i,2)=(l(i)-a(1,1))/rab1
			end do
				end if
	rab1=sqrt(l(1)**2+l(2)**2)
	l(1)=l(1)/rab1
	l(2)=l(2)/rab1
					if (l(1).gt.l(2)) then
					rab1=l(1)
					l(1)=l(2)
					l(2)=rab1
						do i=1,2
					rab1=r(1,i)
					r(1,i)=r(2,i)
					r(2,i)=rab1
						end do
					end if
						RETURN
						END
