TEMPLATE =app
INCLUDEPATH += $(QWTDIR)/include
INCLUDEPATH += .

unix : LIBS +=  -L./FORTRAN -lmomfort -L./LAHIO -lahio -L$(F2C)/lib -lf2c1
HEADERS = mainwindow.h \
                document.h   \
                sei.h        \
                ahhead.h     \
                default.h    \
                projectwizard.h \
                editline.h      \
                appkonsole.h   \
                viewresult.h \
                records.h \
                models.h \
                range.h \
                grid.h \
                polarities.h \
                info.h \
                bulletin.h

SOURCES = main.cpp        \
                mainwindow.cpp  \
                document.cpp    \
                sei.cpp         \
                default.cpp    \
                projectwizard.cpp \
                editline.cpp      \
                appkonsole.cpp    \
                viewresult.cpp \
                records.cpp \
                models.cpp \
                range.cpp \
                grid.cpp \
                polarities.cpp \
                info.cpp \
                bulletin.cpp

FORMS =         test.ui        \
                directories.ui \
                recordlst.ui   \
                models.ui      \
                range.ui       \
                grid.ui        \
                polarity.ui   \
                viewresult.ui \
                info.ui

RESOURCES = momtens.qrc

CONFIG += qt warn_on release
LANGUAGE = C++

UI_DIR = ui
MOC_DIR = moc
OBJECTS_DIR = obj
UI_SOURCES_DIR = .
RCC_DIR = .

unix {
    TARGET =  ../../../bin/momtens
}


