//Added by qt3to4:
#include <QGridLayout>
#include <QLabel>
#include <QFrame>
#include <QCloseEvent>
#include <vector>
using namespace std;
const double _A4_PAGE_HEIGHT_WIDTH_RATIO = 210./297.;

class BodePlot;
class DurationPlot;
class MajorAxisPlot;
class MinorAxisPlot;
class CentroidPlot;
class MajorStrikePlot;
class VelocityStrikePlot;
class Q3PointArray;
class Q3ToolBar;
class QAction;
class QLabel;
class QGridLayout;
class QGroupBox;
class QFrame;
class QComboBox;
class MainWin;
class CDataInfo;
class CDataSet;
class QwtPlotPicker;

typedef vector< vector<CDataSet* >::iterator >::iterator itPlot;
class GraphWin :   public QWidget
{
        Q_OBJECT
public:
 
     GraphWin(QWidget *p ,CDataInfo* dataInfo,const char *name);
     ~GraphWin();
     void ChangeFont(QFont f);
     vector<BodePlot* > vBodePlot;
     vector<QFrame* > vFrame;    
     QGroupBox*   groupBox;
     QGridLayout* MainWindowLayout;   
     QGridLayout* groupBoxLayout; 
    QString header;
    QString footer;  
    MainWin* parentWin;
private:
    DurationPlot *plotDuration;
    MajorAxisPlot *plotMajorAxis;
    MinorAxisPlot *plotMinorAxis;
    CentroidPlot *plotCentroid;
    MajorStrikePlot *plotMajorStrike;
    VelocityStrikePlot *plotVelocityStrike;

    QLabel* textLabel1;
    QLabel* textLabel2;
    CDataInfo* dataInfo;
    int indNormalization;
    int numRow;
    int numCol;
    int numCurve;


};

